gtkmm: Gtk::Widget Class Reference

gtkmm 4.15.1

Classes | Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gtk::Widget Class Reference

Abstract Widget (Base class for all widgets) More...

`#include <gtkmm/widget.h>`

Inheritance diagram for Gtk::Widget:
[legend]

## Classes
struct | Measurements
| Structure returned by the non-output-parameter overload of measure(). More...
struct | MinimumNatural
| Structure holding the minimum and natural sizes of a widget, in some type. More...

## Public Types
using | PreferredSize = MinimumNatural< Requisition >
| Structure returned by the non-output-parameter overload of get_preferred_size().
using | SlotTick = sigc::slot< bool(const Glib::RefPtr< Gdk::FrameClock > &)>
| Callback type for adding a function to update animations.
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from Gtk::Accessible
enum class | Role { Role::ALERT , Role::ALERT_DIALOG , Role::BANNER , Role::BUTTON , Role::CAPTION , Role::CELL , Role::CHECKBOX , Role::COLUMN_HEADER , Role::COMBO_BOX , Role::COMMAND , Role::COMPOSITE , Role::DIALOG , Role::DOCUMENT , Role::FEED , Role::FORM , Role::GENERIC , Role::GRID , Role::GRID_CELL , Role::GROUP , Role::HEADING , Role::IMG , Role::INPUT , Role::LABEL , Role::LANDMARK , Role::LEGEND , Role::LINK , Role::LIST , Role::LIST_BOX , Role::LIST_ITEM , Role::LOG , Role::MAIN , Role::MARQUEE , Role::MATH , Role::METER , Role::MENU , Role::MENU_BAR , Role::MENU_ITEM , Role::MENU_ITEM_CHECKBOX , Role::MENU_ITEM_RADIO , Role::NAVIGATION , Role::NONE , Role::NOTE , Role::OPTION , Role::PRESENTATION , Role::PROGRESS_BAR , Role::RADIO , Role::RADIO_GROUP , Role::RANGE , Role::REGION , Role::ROW , Role::ROW_GROUP , Role::ROW_HEADER , Role::SCROLLBAR , Role::SEARCH , Role::SEARCH_BOX , Role::SECTION , Role::SECTION_HEAD , Role::SELECT , Role::SEPARATOR , Role::SLIDER , Role::SPIN_BUTTON , Role::STATUS , Role::STRUCTURE , Role::SWITCH , Role::TAB , Role::TABLE , Role::TAB_LIST , Role::TAB_PANEL , Role::TEXT_BOX , Role::TIME , Role::TIMER , Role::TOOLBAR , Role::TOOLTIP , Role::TREE , Role::TREE_GRID , Role::TREE_ITEM , Role::WIDGET , Role::WINDOW , Role::TOGGLE_BUTTON , Role::APPLICATION , Role::PARAGRAPH , Role::BLOCK_QUOTE , Role::ARTICLE , Role::COMMENT , Role::TERMINAL }
| The accessible role for a Gtk::Accessible implementation. More...
enum class | State { State::BUSY , State::CHECKED , State::DISABLED , State::EXPANDED , State::HIDDEN , State::INVALID , State::PRESSED , State::SELECTED , State::VISITED }
| The possible accessible states of a Gtk::Accessible. More...
enum class | Property { Property::AUTOCOMPLETE , Property::DESCRIPTION , Property::HAS_POPUP , Property::KEY_SHORTCUTS , Property::LABEL , Property::LEVEL , Property::MODAL , Property::MULTI_LINE , Property::MULTI_SELECTABLE , Property::ORIENTATION , Property::PLACEHOLDER , Property::READ_ONLY , Property::REQUIRED , Property::ROLE_DESCRIPTION , Property::SORT , Property::VALUE_MAX , Property::VALUE_MIN , Property::VALUE_NOW , Property::VALUE_TEXT , Property::HELP_TEXT }
| The possible accessible properties of a Gtk::Accessible. More...
enum class | Relation { Relation::ACTIVE_DESCENDANT , Relation::COL_COUNT , Relation::COL_INDEX , Relation::COL_INDEX_TEXT , Relation::COL_SPAN , Relation::CONTROLS , Relation::DESCRIBED_BY , Relation::DETAILS , Relation::ERROR_MESSAGE , Relation::FLOW_TO , Relation::LABELLED_BY , Relation::OWNS , Relation::POS_IN_SET , Relation::ROW_COUNT , Relation::ROW_INDEX , Relation::ROW_INDEX_TEXT , Relation::ROW_SPAN , Relation::SET_SIZE }
| The possible accessible relations of a Gtk::Accessible. More...
enum class | PlatformState { PlatformState::FOCUSABLE , PlatformState::FOCUSED , PlatformState::ACTIVE }
| The various platform states which can be queried using Gtk::Accessible::get_platform_state(). More...
enum class | AnnouncementPriority { AnnouncementPriority::LOW , AnnouncementPriority::MEDIUM , AnnouncementPriority::HIGH }
| The priority of an accessibility announcement. More...

## Public Member Functions
| Widget (Widget &&src) noexcept
Widget & | operator= (Widget &&src) noexcept
| Widget (const Widget &)=delete
Widget & | operator= (const Widget &)=delete
| ~Widget () noexcept override
| Destroys the widget.
GtkWidget * | gobj ()
| Provides access to the underlying C GObject.
const GtkWidget * | gobj () const
| Provides access to the underlying C GObject.
Glib::RefPtr< ConstraintTarget > | make_refptr_constrainttarget ()
| Converts this widget to a reference counted Gtk::ConstraintTarget.
Glib::RefPtr< const ConstraintTarget > | make_refptr_constrainttarget () const
| Converts this widget to a reference counted Gtk::ConstraintTarget.
void | show ()
| Flags a widget to be displayed.
void | hide ()
| Reverses the effects of show().
void | queue_draw ()
| Schedules this widget to be redrawn in the paint phase of the current or the next frame.
void | queue_resize ()
| Flags a widget to have its size renegotiated.
void | queue_allocate ()
| Flags the widget for a rerun of the size_allocate_vfunc() function.
void | size_allocate (const Allocation &allocation, int baseline)
| Allocates widget with a transformation that translates the origin to the position in allocation.
SizeRequestMode | get_request_mode () const
| Gets whether the widget prefers a height-for-width layout or a width-for-height layout.
void | measure (Orientation orientation, int for_size, int & minimum, int & natural, int &minimum_baseline, int &natural_baseline) const
| Measures widget in the orientation orientation and for the given for_size.
Measurements | measure (Orientation orientation, int for_size=-1) const
| Like the other overload of measure() but returns a structure holding the sizes/baselines instead of using output parameters.
void | get_preferred_size (Requisition &minimum_size, Requisition &natural_size) const
| Retrieves the minimum and natural size of a widget, taking into account the widget’s preference for height-for-width management.
PreferredSize | get_preferred_size () const
| Like the other overload of get_preferred_size() but returns a structure holding the sizes instead of using output parameters.
void | set_layout_manager (const Glib::RefPtr< LayoutManager > &layout_manager)
| Sets the layout manager delegate instance that provides an implementation for measuring and allocating the children of widget.
void | unset_layout_manager ()
| Undoes the effect of a previous call to set_layout_manager().
Glib::RefPtr< LayoutManager > | get_layout_manager ()
| Retrieves the layout manager used by widget.
Glib::RefPtr< const LayoutManager > | get_layout_manager () const
| Retrieves the layout manager used by widget.
bool | mnemonic_activate (bool group_cycling)
| Emits the signal_mnemonic_activate() signal.
bool | activate ()
| For widgets that can be “activated” (buttons, menu items, etc.) this function activates them.
void | set_can_focus (bool can_focus=true)
| Specifies whether the input focus can enter the widget or any of its children.
bool | get_can_focus () const
| Determines whether the input focus can enter widget or any of its children.
void | set_focusable (bool focusable=true)
| Specifies whether widget can own the input focus.
bool | get_focusable () const
| Determines whether widget can own the input focus.
bool | has_focus () const
| Determines if the widget has the global input focus.
bool | is_focus () const
| Determines if the widget is the focus widget within its toplevel.
bool | has_visible_focus () const
| Determines if the widget should show a visible indication that it has the global input focus.
bool | grab_focus ()
| Causes widget to have the keyboard focus for the `Gtk::Window` it's inside.
void | set_focus_on_click (bool focus_on_click=true)
| Sets whether the widget should grab focus when it is clicked with the mouse.
bool | get_focus_on_click () const
| Returns whether the widget should grab focus when it is clicked with the mouse.
void | set_can_target (bool can_target=true)
| Sets whether widget can be the target of pointer events.
bool | get_can_target () const
| Queries whether widget can be the target of pointer events.
bool | has_default () const
| Determines whether widget is the current default widget within its toplevel.
void | set_receives_default (bool receives_default=true)
| Specifies whether widget will be treated as the default widget within its toplevel when it has the focus, even if another widget is the default.
bool | get_receives_default () const
| Determines whether widget is always treated as the default widget within its toplevel when it has the focus, even if another widget is the default.
void | set_name (const Glib::ustring & name)
| Sets a widgets name.
void | unset_name ()
Glib::ustring | get_name () const
| Retrieves the name of a widget.
void | set_state_flags (StateFlags flags, bool clear=true)
| Turns on flag values in the current widget state.
void | unset_state_flags (StateFlags flags)
| Turns off flag values for the current widget state.
StateFlags | get_state_flags () const
| Returns the widget state as a flag set.
void | set_sensitive (bool sensitive=true)
| Sets the sensitivity of a widget.
bool | get_sensitive () const
| Returns the widget’s sensitivity.
bool | is_sensitive () const
| Returns the widget’s effective sensitivity.
void | set_visible (bool visible=true)
| Sets the visibility state of widget.
bool | get_visible () const
| Determines whether the widget is visible.
bool | is_visible () const
| Determines whether the widget and all its parents are marked as visible.
bool | is_drawable () const
| Determines whether widget can be drawn to.
bool | get_realized () const
| Determines whether widget is realized.
bool | get_mapped () const
| Whether the widget is mapped.
void | set_child_visible (bool visible=true)
| Sets whether widget should be mapped along with its parent.
bool | get_child_visible () const
| Gets the value set with set_child_visible().
int | get_allocated_width () const
| Returns the width that has currently been allocated to widget.
int | get_allocated_height () const
| Returns the height that has currently been allocated to widget.
int | get_allocated_baseline () const
| Returns the baseline that has currently been allocated to widget.
Allocation | get_allocation () const
| Retrieves the widget’s location.
std::optional< Gdk::Graphene::Rect > | compute_bounds (const Widget & target) const
| Computes the bounds for the widget in the coordinate space of target.
std::optional< Gdk::Graphene::Point > | compute_point (const Widget & target, const Gdk::Graphene::Point &point) const
| Translates the given point in the widget's coordinates to coordinates relative to target’s coordinate system.
int | get_width () const
| Returns the content width of the widget.
int | get_height () const
| Returns the content height of the widget.
int | get_baseline () const
| Returns the baseline that has currently been allocated to widget.
int | get_size (Orientation orientation) const
| Returns the content width or height of the widget.
Widget * | get_parent ()
| Returns the parent widget of widget.
const Widget * | get_parent () const
| Returns the parent widget of widget.
Root * | get_root ()
| Returns the `Gtk::Root` widget of widget.
const Root * | get_root () const
| Returns the `Gtk::Root` widget of widget.
Native * | get_native ()
| Returns the nearest `Gtk::Native` ancestor of widget.
const Native * | get_native () const
| Returns the nearest `Gtk::Native` ancestor of widget.
bool | child_focus (DirectionType direction)
| Called by widgets as the user moves around the window using keyboard shortcuts.
bool | keynav_failed (DirectionType direction)
| Emits the `keynav-failed` signal on the widget.
void | error_bell ()
| Notifies the user about an input-related error on this widget.
void | set_size_request (int width=-1, int height=-1)
| Sets the minimum size of a widget.
void | get_size_request (int & width, int &height) const
| Gets the size request that was explicitly set for the widget using set_size_request().
Requisition | get_size_request () const
| Like the other overload of get_size_request() but returns a structure holding the sizes instead of using output parameters.
void | set_opacity (double opacity)
| Request the widget to be rendered partially transparent.
double | get_opacity () const
| Fetches the requested opacity for this widget.
void | set_overflow (Overflow overflow)
| Sets how widget treats content that is drawn outside the widget's content area.
Overflow | get_overflow () const
| Returns the widget’s overflow value.
Widget * | get_ancestor (GType widget_type)
| Gets the first ancestor of widget with type widget_type.
const Widget * | get_ancestor (GType widget_type) const
| Gets the first ancestor of widget with type widget_type.
int | get_scale_factor () const
| Retrieves the internal scale factor that maps from window coordinates to the actual device pixels.
Glib::RefPtr< Gdk::Display > | get_display ()
| Get the `Gdk::Display` for the toplevel window associated with this widget.
Glib::RefPtr< const Gdk::Display > | get_display () const
| Get the `Gdk::Display` for the toplevel window associated with this widget.
Glib::RefPtr< Settings > | get_settings ()
| Gets the settings object holding the settings used for this widget.
Glib::RefPtr< Gdk::Clipboard > | get_clipboard ()
| Gets the clipboard object for widget.
Glib::RefPtr< const Gdk::Clipboard > | get_clipboard () const
| Gets the clipboard object for widget.
Glib::RefPtr< Gdk::Clipboard > | get_primary_clipboard ()
| Gets the primary clipboard of widget.
Glib::RefPtr< const Gdk::Clipboard > | get_primary_clipboard () const
| Gets the primary clipboard of widget.
bool | get_hexpand () const
| Gets whether the widget would like any available extra horizontal space.
void | set_hexpand (bool expand=true)
| Sets whether the widget would like any available extra horizontal space.
bool | get_hexpand_set () const
| Gets whether set_hexpand() has been used to explicitly set the expand flag on this widget.
void | set_hexpand_set (bool set=true)
| Sets whether the hexpand flag will be used.
bool | get_vexpand () const
| Gets whether the widget would like any available extra vertical space.
void | set_vexpand (bool expand=true)
| Sets whether the widget would like any available extra vertical space.
bool | get_vexpand_set () const
| Gets whether set_vexpand() has been used to explicitly set the expand flag on this widget.
void | set_vexpand_set (bool set=true)
| Sets whether the vexpand flag will be used.
bool | compute_expand (Orientation orientation)
| Computes whether a container should give this widget extra space when possible.
void | set_expand (bool expand=true)
| Sets whether the widget would like any available extra space in both directions.
Align | get_halign () const
| Gets the horizontal alignment of widget.
void | set_halign (Align align)
| Sets the horizontal alignment of widget.
Align | get_valign () const
| Gets the vertical alignment of widget.
void | set_valign (Align align)
| Sets the vertical alignment of widget.
int | get_margin_start () const
| Gets the start margin of widget.
void | set_margin_start (int margin)
| Sets the start margin of widget.
int | get_margin_end () const
| Gets the end margin of widget.
void | set_margin_end (int margin)
| Sets the end margin of widget.
int | get_margin_top () const
| Gets the top margin of widget.
void | set_margin_top (int margin)
| Sets the top margin of widget.
int | get_margin_bottom () const
| Gets the bottom margin of widget.
void | set_margin_bottom (int margin)
| Sets the bottom margin of widget.
void | set_margin (int margin)
| Set all 4 margins to the same value.
bool | is_ancestor (Widget &ancestor) const
| Determines whether widget is somewhere inside ancestor, possibly with intermediate containers.
bool | translate_coordinates (Widget &dest_widget, double src_x, double src_y, double &dest_x, double &dest_y)
| Translate coordinates relative to src_widget’s allocation to coordinates relative to dest_widget’s allocations.
bool | contains (double x, double y) const
| Tests if the point at ( x, y) is contained in widget.
Widget * | pick (double x, double y, PickFlags flags=PickFlags::DEFAULT)
| Finds the descendant of widget closest to the point ( x, y).
const Widget * | pick (double x, double y, PickFlags flags=PickFlags::DEFAULT) const
| Finds the descendant of widget closest to the point ( x, y).
void | add_controller (const Glib::RefPtr< EventController > &controller)
| Adds controller to widget so that it will receive events.
void | remove_controller (const Glib::RefPtr< EventController > &controller)
| Removes controller from widget, so that it doesn't process events anymore.
Glib::RefPtr< Pango::Context > | create_pango_context ()
| Creates a new `Pango::Context` with the appropriate font map, font options, font description, and base direction for drawing text for this widget.
Glib::RefPtr< Pango::Context > | get_pango_context ()
| Gets a `Pango::Context` with the appropriate font map, font description, and base direction for this widget.
void | set_font_options (const Cairo::FontOptions &options)
| Sets the `cairo_font_options_t` used for Pango rendering in this widget.
void | unset_font_options ()
| Undoes the effect of previous calls to set_font_options().
Cairo::FontOptions | get_font_options () const
| Returns the `cairo_font_options_t` of widget.
Glib::RefPtr< Pango::Layout > | create_pango_layout (const Glib::ustring &text)
| Creates a new `Pango::Layout` with the appropriate font map, font description, and base direction for drawing text for this widget.
void | set_direction (TextDirection dir)
| Sets the reading direction on a particular widget.
TextDirection | get_direction () const
| Gets the reading direction for a particular widget.
void | set_cursor (const Glib::RefPtr< Gdk::Cursor > &cursor)
| Sets the cursor to be shown when pointer devices point towards widget.
void | set_cursor (const Glib::ustring & name={})
| Sets a named cursor to be shown when pointer devices point towards the widget.
Glib::RefPtr< Gdk::Cursor > | get_cursor ()
| Queries the cursor set on widget.
Glib::RefPtr< const Gdk::Cursor > | get_cursor () const
| Queries the cursor set on widget.
std::vector< Widget * > | list_mnemonic_labels ()
| Returns the widgets for which this widget is the target of a mnemonic.
std::vector< const Widget * > | list_mnemonic_labels () const
| Returns the widgets for which this widget is the target of a mnemonic.
void | add_mnemonic_label (Widget &label)
| Adds a widget to the list of mnemonic labels for this widget.
void | remove_mnemonic_label (Widget &label)
| Removes a widget from the list of mnemonic labels for this widget.
bool | drag_check_threshold (int start_x, int start_y, int current_x, int current_y)
| Checks to see if a drag movement has passed the GTK drag threshold.
Glib::RefPtr< Gdk::FrameClock > | get_frame_clock ()
| Obtains the frame clock for a widget.
Glib::RefPtr< const Gdk::FrameClock > | get_frame_clock () const
| Obtains the frame clock for a widget.
void | set_parent (Widget & parent)
| Sets parent as the parent widget of widget.
void | unparent ()
| Dissociate widget from its parent.
void | map ()
| Causes a widget to be mapped if it isn’t already.
void | unmap ()
| Causes a widget to be unmapped if it’s currently mapped.
void | trigger_tooltip_query ()
| Triggers a tooltip query on the display where the toplevel of widget is located.
void | set_tooltip_text (const Glib::ustring &text)
| Sets text as the contents of the tooltip.
Glib::ustring | get_tooltip_text () const
| Gets the contents of the tooltip for widget.
void | set_tooltip_markup (const Glib::ustring &markup)
| Sets markup as the contents of the tooltip, which is marked up with the Pango text markup language.
Glib::ustring | get_tooltip_markup () const
| Gets the contents of the tooltip for widget.
void | set_has_tooltip (bool has_tooltip=TRUE)
| Sets the `has-tooltip` property on widget to has_tooltip.
bool | get_has_tooltip () const
| Returns the current value of the `has-tooltip` property.
bool | in_destruction () const
| Returns whether the widget is currently being destroyed.
Glib::RefPtr< StyleContext > | get_style_context ()
| Returns the style context associated to widget.
Glib::RefPtr< const StyleContext > | get_style_context () const
| Returns the style context associated to widget.
guint | add_tick_callback (const SlotTick & slot)
| Queues an animation frame update and adds a callback to be called before each frame.
void | remove_tick_callback (guint id)
| Removes a tick callback previously registered with add_tick_callback().
void | insert_action_group (const Glib::ustring & name, const Glib::RefPtr< Gio::ActionGroup > & group)
| Inserts group into widget.
void | remove_action_group (const Glib::ustring & name)
| Removes a group from the widget.
bool | activate_action (const Glib::ustring & name, const Glib::VariantBase &args={})
| Looks up the action in the action groups associated with the widget and its ancestors, and activates it.
void | activate_default ()
| Activates the `default.activate` action from widget.
void | set_font_map (const Glib::RefPtr< Pango::FontMap > &font_map)
| Sets the font map to use for Pango rendering.
Glib::RefPtr< Pango::FontMap > | get_font_map ()
| Gets the font map of widget.
Glib::RefPtr< const Pango::FontMap > | get_font_map () const
| Gets the font map of widget.
Widget * | get_first_child ()
| Returns the widget’s first child.
const Widget * | get_first_child () const
| Returns the widget’s first child.
Widget * | get_last_child ()
| Returns the widget’s last child.
const Widget * | get_last_child () const
| Returns the widget’s last child.
Widget * | get_next_sibling ()
| Returns the widget’s next sibling.
const Widget * | get_next_sibling () const
| Returns the widget’s next sibling.
Widget * | get_prev_sibling ()
| Returns the widget’s previous sibling.
const Widget * | get_prev_sibling () const
| Returns the widget’s previous sibling.
std::vector< Widget * > | get_children ()
| Gets a vector of the widgetʼs current children, from first child to last.
std::vector< const Widget * > | get_children () const
| Gets a vector of the widgetʼs current children, from first child to last.
Glib::RefPtr< Gio::ListModel > | observe_children ()
| Returns a `Gio::ListModel` to track the children of widget.
Glib::RefPtr< const Gio::ListModel > | observe_children () const
| Returns a `Gio::ListModel` to track the children of widget.
Glib::RefPtr< Gio::ListModel > | observe_controllers ()
| Returns a `Gio::ListModel` to track the Gtk::EventControllers of widget.
Glib::RefPtr< const Gio::ListModel > | observe_controllers () const
| Returns a `Gio::ListModel` to track the Gtk::EventControllers of widget.
void | insert_after (Widget & parent, const Widget &previous_sibling)
| Inserts the Widget into the child widget list of parent after previous_sibling.
void | insert_before (Widget & parent, const Widget & next_sibling)
| Inserts the Widget into the child widget list of parent before next_sibling.
void | insert_at_start (Widget & parent)
| Inserts the Widget at the beginning of the child widget list of parent.
void | insert_at_end (Widget & parent)
| Inserts the Widget at the end of the child widget list of parent.
void | snapshot_child (Widget &child, const Glib::RefPtr< Gtk::Snapshot > & snapshot)
| Snapshot the a child of widget.
bool | should_layout () const
| Returns whether widget should contribute to the measuring and allocation of its parent.
Glib::ustring | get_css_name () const
| Returns the CSS name that is used for self.
void | add_css_class (const Glib::ustring &css_class)
| Adds a style class to widget.
void | remove_css_class (const Glib::ustring &css_class)
| Removes a style from widget.
bool | has_css_class (const Glib::ustring &css_class) const
| Returns whether css_class is currently applied to widget.
std::vector< Glib::ustring > | get_css_classes () const
| Returns the list of style classes applied to widget.
void | set_css_classes (const std::vector< Glib::ustring > &classes)
| Clear all style classes applied to widget and replace them with classes.
Gdk::RGBA | get_color () const
| Gets the current foreground color for the widget's CSS style.
Glib::SignalProxy< void()> | signal_show ()
Glib::SignalProxy< void()> | signal_hide ()
Glib::SignalProxy< void()> | signal_map ()
| Emitted on mapping of a widget to the screen.
Glib::SignalProxy< void()> | signal_unmap ()
Glib::SignalProxy< void()> | signal_realize ()
| Emitted on realization of a widget.
Glib::SignalProxy< void()> | signal_unrealize ()
Glib::SignalProxy< void(Gtk::StateFlags)> | signal_state_flags_changed ()
Glib::SignalProxy< void(TextDirection)> | signal_direction_changed ()
Glib::SignalProxy< bool(bool)> | signal_mnemonic_activate ()
Glib::SignalProxy< void()> | signal_destroy ()
| Emitted during the dispose phase.
Glib::SignalProxy< bool(int, int, bool, const Glib::RefPtr< Tooltip > &)> | signal_query_tooltip ()
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name of the widget.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name of the widget.
Glib::PropertyProxy_ReadOnly< Widget * > | property_parent () const
| The parent widget of this widget.
Glib::PropertyProxy_ReadOnly< Root * > | property_root () const
| The `Gtk::Root` widget of the widget tree containing this widget.
Glib::PropertyProxy< int > | property_width_request ()
| Override for width request of the widget.
Glib::PropertyProxy_ReadOnly< int > | property_width_request () const
| Override for width request of the widget.
Glib::PropertyProxy< int > | property_height_request ()
| Override for height request of the widget.
Glib::PropertyProxy_ReadOnly< int > | property_height_request () const
| Override for height request of the widget.
Glib::PropertyProxy< bool > | property_visible ()
| Whether the widget is visible.
Glib::PropertyProxy_ReadOnly< bool > | property_visible () const
| Whether the widget is visible.
Glib::PropertyProxy< bool > | property_sensitive ()
| Whether the widget responds to input.
Glib::PropertyProxy_ReadOnly< bool > | property_sensitive () const
| Whether the widget responds to input.
Glib::PropertyProxy< bool > | property_can_focus ()
| Whether the widget or any of its descendents can accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_can_focus () const
| Whether the widget or any of its descendents can accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_has_focus () const
| Whether the widget has the input focus.
Glib::PropertyProxy< bool > | property_can_target ()
| Whether the widget can receive pointer events.
Glib::PropertyProxy_ReadOnly< bool > | property_can_target () const
| Whether the widget can receive pointer events.
Glib::PropertyProxy< bool > | property_focus_on_click ()
| Whether the widget should grab focus when it is clicked with the mouse.
Glib::PropertyProxy_ReadOnly< bool > | property_focus_on_click () const
| Whether the widget should grab focus when it is clicked with the mouse.
Glib::PropertyProxy< bool > | property_focusable ()
| Whether this widget itself will accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_focusable () const
| Whether this widget itself will accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_has_default () const
| Whether the widget is the default widget.
Glib::PropertyProxy< bool > | property_receives_default ()
| Whether the widget will receive the default action when it is focused.
Glib::PropertyProxy_ReadOnly< bool > | property_receives_default () const
| Whether the widget will receive the default action when it is focused.
Glib::PropertyProxy< Glib::RefPtr< Gdk::Cursor > > | property_cursor ()
| The cursor used by widget.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Cursor > > | property_cursor () const
| The cursor used by widget.
Glib::PropertyProxy< bool > | property_has_tooltip ()
| Enables or disables the emission of the signal_query_tooltip() signal on widget.
Glib::PropertyProxy_ReadOnly< bool > | property_has_tooltip () const
| Enables or disables the emission of the signal_query_tooltip() signal on widget.
Glib::PropertyProxy< Glib::ustring > | property_tooltip_markup ()
| Sets the text of tooltip to be the given string, which is marked up with Pango markup.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_markup () const
| Sets the text of tooltip to be the given string, which is marked up with Pango markup.
Glib::PropertyProxy< Glib::ustring > | property_tooltip_text ()
| Sets the text of tooltip to be the given string.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_text () const
| Sets the text of tooltip to be the given string.
Glib::PropertyProxy< Align > | property_halign ()
| How to distribute horizontal space if widget gets extra space.
Glib::PropertyProxy_ReadOnly< Align > | property_halign () const
| How to distribute horizontal space if widget gets extra space.
Glib::PropertyProxy< Align > | property_valign ()
| How to distribute vertical space if widget gets extra space.
Glib::PropertyProxy_ReadOnly< Align > | property_valign () const
| How to distribute vertical space if widget gets extra space.
Glib::PropertyProxy< int > | property_margin_start ()
| Margin on start of widget, horizontally.
Glib::PropertyProxy_ReadOnly< int > | property_margin_start () const
| Margin on start of widget, horizontally.
Glib::PropertyProxy< int > | property_margin_end ()
| Margin on end of widget, horizontally.
Glib::PropertyProxy_ReadOnly< int > | property_margin_end () const
| Margin on end of widget, horizontally.
Glib::PropertyProxy< int > | property_margin_top ()
| Margin on top side of widget.
Glib::PropertyProxy_ReadOnly< int > | property_margin_top () const
| Margin on top side of widget.
Glib::PropertyProxy< int > | property_margin_bottom ()
| Margin on bottom side of widget.
Glib::PropertyProxy_ReadOnly< int > | property_margin_bottom () const
| Margin on bottom side of widget.
Glib::PropertyProxy< bool > | property_hexpand ()
| Whether to expand horizontally.
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand () const
| Whether to expand horizontally.
Glib::PropertyProxy< bool > | property_hexpand_set ()
| Whether to use the `hexpand` property.
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand_set () const
| Whether to use the `hexpand` property.
Glib::PropertyProxy< bool > | property_vexpand ()
| Whether to expand vertically.
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand () const
| Whether to expand vertically.
Glib::PropertyProxy< bool > | property_vexpand_set ()
| Whether to use the `vexpand` property.
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand_set () const
| Whether to use the `vexpand` property.
Glib::PropertyProxy< double > | property_opacity ()
| The requested opacity of the widget.
Glib::PropertyProxy_ReadOnly< double > | property_opacity () const
| The requested opacity of the widget.
Glib::PropertyProxy< Overflow > | property_overflow ()
| How content outside the widget's content area is treated.
Glib::PropertyProxy_ReadOnly< Overflow > | property_overflow () const
| How content outside the widget's content area is treated.
Glib::PropertyProxy_ReadOnly< int > | property_scale_factor () const
| The scale factor of the widget.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_css_name () const
| The name of this widget in the CSS tree.
Glib::PropertyProxy< std::vector< Glib::ustring > > | property_css_classes ()
| A list of css classes applied to this widget.
Glib::PropertyProxy_ReadOnly< std::vector< Glib::ustring > > | property_css_classes () const
| A list of css classes applied to this widget.
Glib::PropertyProxy< Glib::RefPtr< LayoutManager > > | property_layout_manager ()
| The `Gtk::LayoutManager` instance to use to compute the preferred size of the widget, and allocate its children.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< LayoutManager > > | property_layout_manager () const
| The `Gtk::LayoutManager` instance to use to compute the preferred size of the widget, and allocate its children.
Public Member Functions inherited from Gtk::Object
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
| ~Object () noexcept override
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gtk::Accessible
| Accessible (Accessible &&src) noexcept
Accessible & | operator= (Accessible &&src) noexcept
| ~Accessible () noexcept override
GtkAccessible * | gobj ()
| Provides access to the underlying C GObject.
const GtkAccessible * | gobj () const
| Provides access to the underlying C GObject.
Glib::RefPtr< ATContext > | get_at_context ()
| Retrieves the accessible implementation for the given `Gtk::Accessible`.
Glib::RefPtr< const ATContext > | get_at_context () const
| Retrieves the accessible implementation for the given `Gtk::Accessible`.
bool | get_platform_state (PlatformState state) const
| Query a platform state, such as focus.
Glib::RefPtr< Accessible > | get_accessible_parent ()
| Retrieves the accessible parent for an accessible object.
Glib::RefPtr< const Accessible > | get_accessible_parent () const
| Retrieves the accessible parent for an accessible object.
void | set_accessible_parent (const Glib::RefPtr< Accessible > & parent, const Glib::RefPtr< Accessible > & next_sibling)
| Sets the parent and sibling of an accessible object.
Glib::RefPtr< Accessible > | get_first_accessible_child ()
| Retrieves the first accessible child of an accessible object.
Glib::RefPtr< const Accessible > | get_first_accessible_child () const
| Retrieves the first accessible child of an accessible object.
Glib::RefPtr< Accessible > | get_next_accessible_sibling ()
| Retrieves the next accessible sibling of an accessible object.
Glib::RefPtr< const Accessible > | get_next_accessible_sibling () const
| Retrieves the next accessible sibling of an accessible object.
void | update_next_accessible_sibling (const Glib::RefPtr< Accessible > &new_sibling)
| Updates the next accessible sibling of self.
bool | get_bounds (int &x, int &y, int & width, int &height) const
| Queries the coordinates and dimensions of this accessible.
Role | get_accessible_role () const
| Retrieves the accessible role of an accessible object.
void | update_state (State state, const Glib::ValueBase & value)
| Updates an accessible state.
void | update_property (Property property, const Glib::ValueBase & value)
| Updates an accessible property.
void | update_relation (Relation relation, const Glib::ValueBase & value)
| Updates an accessible relation.
void | reset_state (State state)
| Resets the accessible state to its default value.
void | reset_property (Property property)
| Resets the accessible property to its default value.
void | reset_relation (Relation relation)
| Resets the accessible relation to its default value.
void | announce (const Glib::ustring & message, AnnouncementPriority priority)
| Requests the user's screen reader to announce the given message.
Glib::PropertyProxy< Role > | property_accessible_role ()
| The accessible role of the given `Gtk::Accessible` implementation.
Glib::PropertyProxy_ReadOnly< Role > | property_accessible_role () const
| The accessible role of the given `Gtk::Accessible` implementation.
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Gtk::Buildable
| Buildable (Buildable &&src) noexcept
Buildable & | operator= (Buildable &&src) noexcept
| ~Buildable () noexcept override
GtkBuildable * | gobj ()
| Provides access to the underlying C GObject.
const GtkBuildable * | gobj () const
| Provides access to the underlying C GObject.
Glib::ustring | get_buildable_id () const
| Gets the ID of the buildable object.
Public Member Functions inherited from Gtk::ConstraintTarget
| ConstraintTarget (ConstraintTarget &&src) noexcept
ConstraintTarget & | operator= (ConstraintTarget &&src) noexcept
| ~ConstraintTarget () noexcept override
GtkConstraintTarget * | gobj ()
| Provides access to the underlying C GObject.
const GtkConstraintTarget * | gobj () const
| Provides access to the underlying C GObject.

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static void | set_default_direction (TextDirection dir)
| Sets the default reading direction for widgets.
static TextDirection | get_default_direction ()
| Obtains the current default reading direction.
Static Public Member Functions inherited from Gtk::Accessible
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Buildable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::ConstraintTarget
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
virtual void | root_vfunc ()
virtual void | unroot_vfunc ()
virtual void | size_allocate_vfunc (int width, int height, int baseline)
virtual SizeRequestMode | get_request_mode_vfunc () const
virtual void | measure_vfunc (Orientation orientation, int for_size, int & minimum, int & natural, int &minimum_baseline, int &natural_baseline) const
virtual bool | grab_focus_vfunc ()
virtual void | set_focus_child_vfunc (Widget *child)
| Sets the focused child of widget.
virtual void | compute_expand_vfunc (bool &hexpand_p, bool &vexpand_p)
virtual bool | contains_vfunc (double x, double y) const
virtual void | snapshot_vfunc (const Glib::RefPtr< Gtk::Snapshot > & snapshot)
| Widget ()
void | realize ()
| Creates the GDK resources associated with a widget.
void | unrealize ()
| Causes a widget to be unrealized (frees all GDK resources associated with the widget).
void | realize_if_needed ()
void | set_focus_child (Widget &child)
| Set child as the current focus child of widget.
void | unset_focus_child ()
| Unsets the focus child of the widget.
Widget * | get_focus_child ()
| Returns the current focus child of widget.
const Widget * | get_focus_child () const
| Returns the current focus child of widget.
virtual void | on_show ()
| This is a default handler for the signal signal_show().
virtual void | on_hide ()
| This is a default handler for the signal signal_hide().
virtual void | on_map ()
| This is a default handler for the signal signal_map().
virtual void | on_unmap ()
| This is a default handler for the signal signal_unmap().
virtual void | on_realize ()
| This is a default handler for the signal signal_realize().
virtual void | on_unrealize ()
| This is a default handler for the signal signal_unrealize().
virtual void | on_state_flags_changed (Gtk::StateFlags previous_state_flags)
| This is a default handler for the signal signal_state_flags_changed().
virtual void | on_direction_changed (TextDirection direction)
| This is a default handler for the signal signal_direction_changed().
virtual bool | on_mnemonic_activate (bool group_cycling)
| This is a default handler for the signal signal_mnemonic_activate().
virtual bool | on_query_tooltip (int x, int y, bool keyboard_tooltip, const Glib::RefPtr< Tooltip > &tooltip)
| This is a default handler for the signal signal_query_tooltip().
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gtk::Accessible
| Accessible ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gtk::Buildable
| Buildable ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gtk::ConstraintTarget
| ConstraintTarget ()
| You should derive from this class to use it.

## Related Symbols
(Note that these are not member symbols.)
Gtk::Widget * | wrap (GtkWidget *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Accessible
Glib::RefPtr< Gtk::Accessible > | wrap (GtkAccessible *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Buildable
Glib::RefPtr< Gtk::Buildable > | wrap (GtkBuildable *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::ConstraintTarget
Glib::RefPtr< Gtk::ConstraintTarget > | wrap (GtkConstraintTarget *object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Abstract Widget (Base class for all widgets)

As the base class of all widgets this contains all of the properties and methods common to all widgets. It manages the widget lifecycle, layout, states and style. It is an abstract class that cannot be instantiated.

An important part of widgets are events that can be trapped by adding event controllers with add_controller(). Those are events coming directly from GDK. By using event controllers you can trap everything a widget can ever do. The Event Controllers and Gestures group lists the event controller classes.

Most widgets are added as children to a container widget, such as a Box, Grid or Window. A child widget can be managed or non-managed. A managed widget is created with the Gtk::make_managed() template function. Such a widget is deleted when its parent container is deleted. By default widgets are non-managed. This is fine for widgets declared as data members of a class. They are not deleted when their parent is deleted, but when the containing class instance is deleted. Memory management of widgets is described in more detail in the Memory management chapter in the Programming with gtkmm book.

## Member Typedef Documentation

## ◆ PreferredSize

using Gtk::Widget::PreferredSize = MinimumNatural<Requisition>

Structure returned by the non-output-parameter overload of get_preferred_size().

Since gtkmm 4.14:

## ◆ SlotTick

using Gtk::Widget::SlotTick = sigc::slot<bool(const Glib::RefPtr<Gdk::FrameClock>&)>

Callback type for adding a function to update animations.

See add_tick_callback().

For instance:

bool on_tick(const Glib::RefPtr<Gdk::FrameClock>& frame_clock);
std::shared_ptr

Parameters

  frame_clock | The frame clock for the widget (same as calling get_frame_clock()).

Returns
  `true` if the tick callback should continue to be called, `false` if the tick callback should be removed.

Since gtkmm 3.24:

## Constructor & Destructor Documentation

## ◆ Widget() [1/3]

Gtk::Widget::Widget | ( | Widget && | src | ) |
| noexcept

## ◆ Widget() [2/3]

Gtk::Widget::Widget | ( | const Widget & |  | ) |
| delete

## ◆ ~Widget()

Gtk::Widget::~Widget | ( |  | ) |
| overridenoexcept

Destroys the widget.

Except: if the widget has a parent, only the C++ wrapper is destroyed, not the C instance; please see the “Memory management” chapter in the Programming with gtkmm book as linked in the intro.

## ◆ Widget() [3/3]

Gtk::Widget::Widget | ( |  | ) |
| protected

## Member Function Documentation

## ◆ activate()

bool Gtk::Widget::activate | ( |  | ) |

For widgets that can be “activated” (buttons, menu items, etc.) this function activates them.

The activation will emit the signal set using gtk_widget_class_set_activate_signal() during class initialization.

Activation is what happens when you press Enter on a widget during key navigation.

If you wish to handle the activation keybinding yourself, it is recommended to use gtk_widget_class_add_shortcut() with an action created with Gtk::SignalAction::create().

Returns
  `true` if the widget was activatable, else `false`.

## ◆ activate_action()

bool Gtk::Widget::activate_action | ( | const Glib::ustring & | name,
|  | const Glib::VariantBase & | args = `{}`
| ) |  |

Looks up the action in the action groups associated with the widget and its ancestors, and activates it.

If the action is in an action group added with insert_action_group(), the name is expected to be prefixed with the prefix that was used when the group was inserted.

The arguments must match the action's expected parameter type, as returned by Gio::Action::get_parameter_type().

Parameters

  name | The name of the action to activate.
  args | Parameters to use, or an empty (invalid) Glib::VariantBase if the action does not expect parameters.

Returns
  `true` if the action was activated, `false` if the action does not exist.

## ◆ activate_default()

void Gtk::Widget::activate_default | ( |  | ) |

Activates the `default.activate` action from widget.

## ◆ add_controller()

void Gtk::Widget::add_controller | ( | const Glib::RefPtr< EventController > & | controller | ) |

Adds controller to widget so that it will receive events.

You will usually want to call this function right after creating any kind of Gtk::EventController.

Parameters

  controller | A `Gtk::EventController` that hasn't been added to a widget yet.

## ◆ add_css_class()

void Gtk::Widget::add_css_class | ( | const Glib::ustring & | css_class | ) |

Adds a style class to widget.

After calling this function, the widget’s style will match for css_class, according to CSS matching rules.

Use remove_css_class() to remove the style again.

Parameters

  css_class | The style class to add to widget, without the leading '.' used for notation of style classes.

## ◆ add_mnemonic_label()

void Gtk::Widget::add_mnemonic_label | ( | Widget & | label | ) |

Adds a widget to the list of mnemonic labels for this widget.

(See list_mnemonic_labels()). Note the list of mnemonic labels for the widget is cleared when the widget is destroyed, so the caller must make sure to update its internal state at this point as well.

Since gtkmm 2.4:

Parameters

  label | A `Gtk::Widget` that acts as a mnemonic label for widget.

## ◆ add_tick_callback()

guint Gtk::Widget::add_tick_callback | ( | const SlotTick & | slot | ) |

Queues an animation frame update and adds a callback to be called before each frame.

Until the tick callback is removed, it will be called frequently (usually at the frame rate of the output device or as quickly as the application can be repainted, whichever is slower). For this reason, is most suitable for handling graphics that change every frame or every few frames. The tick callback does not automatically imply a relayout or repaint. If you want a repaint or relayout, and aren’t changing widget properties that would trigger that (for example, changing the text of a Gtk::Label), then you will have to call queue_resize() or queue_draw_area() yourself.

Gdk::FrameClock::get_frame_time() should generally be used for timing continuous animations and Gdk::FrameTimings::get_predicted_presentation_time() if you are trying to display isolated frames at particular times.

This is a more convenient alternative to connecting directly to the Gdk::FrameClock::signal_update() signal of Gdk::FrameClock, since you don't have to worry about when a Gdk::FrameClock is assigned to a widget.

Since gtkmm 3.24:

Parameters

  slot | Slot to call for updating animations.

Returns
  An id for the connection of this callback. Remove the callback by passing it to remove_tick_callback().

## ◆ child_focus()

bool Gtk::Widget::child_focus | ( | DirectionType | direction | ) |

Called by widgets as the user moves around the window using keyboard shortcuts.

The direction argument indicates what kind of motion is taking place (up, down, left, right, tab forward, tab backward).

This function calls the focus_vfunc() virtual function; widgets can override the virtual function in order to implement appropriate focus behavior.

The default `focus()` virtual function for a widget should return `true` if moving in direction left the focus on a focusable location inside that widget, and `false` if moving in direction moved the focus outside the widget. When returning `true`, widgets normally call grab_focus() to place the focus accordingly; when returning `false`, they don’t modify the current focus location.

This function is used by custom widget implementations; if you're writing an app, you’d use grab_focus() to move the focus to a particular widget.

Parameters

  direction | Direction of focus movement.

Returns
  `true` if focus ended up inside widget.

## ◆ compute_bounds()

std::optional< Gdk::Graphene::Rect > Gtk::Widget::compute_bounds | ( | const Widget & | target | ) | const

Computes the bounds for the widget in the coordinate space of target.

The bounds of widget are (the bounding box of) the region that it is expected to draw in.

If the operation is successful, a std::optional<Gdk::Graphene::Rect> that contains a value is returned. If the widget has no bounds or the bounds cannot be expressed in target's coordinate space (for example if both widgets are in different windows), the returned std::optional is empty.

It is valid for the widget and target to be the same widget.

Since gtkmm 4.12:

Parameters

  target | The `Gtk::Widget`.

Returns
  A std::optional<Gdk::Graphene::Rect>, containing a value if the bounds could be computed.

## ◆ compute_expand()

bool Gtk::Widget::compute_expand | ( | Orientation | orientation | ) |

Computes whether a container should give this widget extra space when possible.

Containers should check this, rather than looking at get_hexpand() or get_vexpand().

This function already checks whether the widget is visible, so visibility does not need to be checked separately. Non-visible widgets are not expanded.

The computed expand value uses either the expand setting explicitly set on the widget itself, or, if none has been explicitly set, the widget may expand if some of its children do.

Parameters

  orientation | Expand direction.

Returns
  Whether widget tree rooted here should be expanded.

## ◆ compute_expand_vfunc()

virtual void Gtk::Widget::compute_expand_vfunc | ( | bool & | hexpand_p,
|  | bool & | vexpand_p
| ) |  |
| protectedvirtual

## ◆ compute_point()

std::optional< Gdk::Graphene::Point > Gtk::Widget::compute_point | ( | const Widget & | target,
|  | const Gdk::Graphene::Point & | point
| ) |  | const

Translates the given point in the widget's coordinates to coordinates relative to target’s coordinate system.

In order to perform this operation, both widgets must share a common ancestor.

Since gtkmm 4.12:

Parameters

  target | The `Gtk::Widget` to transform into.
  point | A point in the widget's coordinate system.

Returns
  A std::optional<Gdk::Graphene::Point>, containing a value if the point could be determined.

## ◆ contains()

bool Gtk::Widget::contains | ( | double | x,
|  | double | y
| ) |  | const

Tests if the point at ( x, y) is contained in widget.

The coordinates for ( x, y) must be in widget coordinates, so (0, 0) is assumed to be the top left of widget's content area.

Parameters

  x | X coordinate to test, relative to widget's origin.
  y | Y coordinate to test, relative to widget's origin.

Returns
  `true` if widget contains ( x, y).

## ◆ contains_vfunc()

virtual bool Gtk::Widget::contains_vfunc | ( | double | x,
|  | double | y
| ) |  | const
| protectedvirtual

## ◆ create_pango_context()

Glib::RefPtr< Pango::Context > Gtk::Widget::create_pango_context | ( |  | ) |

Creates a new `Pango::Context` with the appropriate font map, font options, font description, and base direction for drawing text for this widget.

See also get_pango_context().

Returns
  The new `Pango::Context`.

## ◆ create_pango_layout()

Glib::RefPtr< Pango::Layout > Gtk::Widget::create_pango_layout | ( | const Glib::ustring & | text | ) |

Creates a new `Pango::Layout` with the appropriate font map, font description, and base direction for drawing text for this widget.

If you keep a `Pango::Layout` created in this way around, you need to re-create it when the widget `Pango::Context` is replaced. This can be tracked by listening to changes of the property_root() property on the widget.

Parameters

  text | Text to set on the layout.

Returns
  The new `Pango::Layout`.

## ◆ drag_check_threshold()

bool Gtk::Widget::drag_check_threshold | ( | int | start_x,
|  | int | start_y,
|  | int | current_x,
|  | int | current_y
| ) |  |

Checks to see if a drag movement has passed the GTK drag threshold.

Parameters

  start_x | X coordinate of start of drag.
  start_y | Y coordinate of start of drag.
  current_x | Current X coordinate.
  current_y | Current Y coordinate.

Returns
  `true` if the drag threshold has been passed.

## ◆ error_bell()

void Gtk::Widget::error_bell | ( |  | ) |

Notifies the user about an input-related error on this widget.

If the Gtk::Settings gtk-error-bell property is true, it calls Gdk::Surface::beep(), otherwise it does nothing.

Note that the effect of Gdk::Surface::beep() can be configured in many ways, depending on the windowing backend and the desktop environment or window manager that is used.

Since gtkmm 2.12:

## ◆ get_allocated_baseline()

int Gtk::Widget::get_allocated_baseline | ( |  | ) | const

Returns the baseline that has currently been allocated to widget.

This function is intended to be used when implementing handlers for the `Gtk::Widget`Class.snapshot() function, and when allocating child widgets in `Gtk::Widget`Class.size_allocate().

Deprecated: 4.12: Use get_baseline() instead

Deprecated:
  Use get_baseline() instead.

Returns
  The baseline of the widget, or -1 if none.

## ◆ get_allocated_height()

int Gtk::Widget::get_allocated_height | ( |  | ) | const

Returns the height that has currently been allocated to widget.

To learn more about widget sizes, see the coordinate system overview.

Deprecated: 4.12: Use get_height() instead

Deprecated:
  Use get_height() instead.

Returns
  The height of the widget.

## ◆ get_allocated_width()

int Gtk::Widget::get_allocated_width | ( |  | ) | const

Returns the width that has currently been allocated to widget.

To learn more about widget sizes, see the coordinate system overview.

Deprecated: 4.12: Use get_width() instead

Deprecated:
  Use get_width() instead.

Returns
  The width of the widget.

## ◆ get_allocation()

Allocation Gtk::Widget::get_allocation | ( |  | ) | const

Retrieves the widget’s location.

Note, when implementing a layout container: a widget’s allocation will be its “adjusted” allocation, that is, the widget’s parent container typically calls size_allocate() with an allocation, and that allocation is then adjusted (to handle margin and alignment for example) before assignment to the widget. get_allocation() returns the adjusted allocation that was actually assigned to the widget. The adjusted allocation is guaranteed to be completely contained within the size_allocate() allocation, however.

So a layout container is guaranteed that its children stay inside the assigned bounds, but not that they have exactly the bounds the container assigned.

Deprecated:
  4.12: Use compute_bounds() or get_width() instead.

Returns
  The widget’s allocated area.

## ◆ get_ancestor() [1/2]

Widget * Gtk::Widget::get_ancestor | ( | GType | widget_type | ) |

Gets the first ancestor of widget with type widget_type.

For example, `gtk_widget_get_ancestor (widget, GTK_TYPE_BOX)` gets the first `Gtk::Box` that’s an ancestor of widget. No reference will be added to the returned widget; it should not be unreferenced.

Note that unlike is_ancestor(), this function considers widget to be an ancestor of itself.

Parameters

  widget_type | Ancestor type.

Returns
  The ancestor widget.

## ◆ get_ancestor() [2/2]

const Widget * Gtk::Widget::get_ancestor | ( | GType | widget_type | ) | const

Gets the first ancestor of widget with type widget_type.

For example, `gtk_widget_get_ancestor (widget, GTK_TYPE_BOX)` gets the first `Gtk::Box` that’s an ancestor of widget. No reference will be added to the returned widget; it should not be unreferenced.

Note that unlike is_ancestor(), this function considers widget to be an ancestor of itself.

Parameters

  widget_type | Ancestor type.

Returns
  The ancestor widget.

## ◆ get_baseline()

int Gtk::Widget::get_baseline | ( |  | ) | const

Returns the baseline that has currently been allocated to widget.

This function is intended to be used when implementing handlers for the `Gtk::Widget`Class.snapshot() function, and when allocating child widgets in `Gtk::Widget`Class.size_allocate().

Since gtkmm 4.12:

Returns
  The baseline of the widget, or -1 if none.

## ◆ get_can_focus()

bool Gtk::Widget::get_can_focus | ( |  | ) | const

Determines whether the input focus can enter widget or any of its children.

See set_focusable().

Returns
  `true` if the input focus can enter widget, `false` otherwise.

## ◆ get_can_target()

bool Gtk::Widget::get_can_target | ( |  | ) | const

Queries whether widget can be the target of pointer events.

Returns
  `true` if widget can receive pointer events.

## ◆ get_child_visible()

bool Gtk::Widget::get_child_visible | ( |  | ) | const

Gets the value set with set_child_visible().

If you feel a need to use this function, your code probably needs reorganization.

This function is only useful for container implementations and should never be called by an application.

Returns
  `true` if the widget is mapped with the parent.

## ◆ get_children() [1/2]

std::vector< Widget * > Gtk::Widget::get_children | ( |  | ) |

Gets a vector of the widgetʼs current children, from first child to last.

Unlike observe_children(), this does not incur extra bookkeeping to track children, update or emit signal when they change, etc. – so it is faster.

Returns
  A new vector of current children, in order of first child to last.

Since gtkmm 4.14:

## ◆ get_children() [2/2]

std::vector< const Widget * > Gtk::Widget::get_children | ( |  | ) | const

Gets a vector of the widgetʼs current children, from first child to last.

Unlike observe_children(), this does not incur extra bookkeeping to track children, update or emit signal when they change, etc. – so it is faster.

Returns
  A new vector of current children, in order of first child to last.

Since gtkmm 4.14:

## ◆ get_clipboard() [1/2]

Glib::RefPtr< Gdk::Clipboard > Gtk::Widget::get_clipboard | ( |  | ) |

Gets the clipboard object for widget.

This is a utility function to get the clipboard object for the `Gdk::Display` that widget is using.

Note that this function always works, even when widget is not realized yet.

Returns
  The appropriate clipboard object.

## ◆ get_clipboard() [2/2]

Glib::RefPtr< const Gdk::Clipboard > Gtk::Widget::get_clipboard | ( |  | ) | const

Gets the clipboard object for widget.

This is a utility function to get the clipboard object for the `Gdk::Display` that widget is using.

Note that this function always works, even when widget is not realized yet.

Returns
  The appropriate clipboard object.

## ◆ get_color()

Gdk::RGBA Gtk::Widget::get_color | ( |  | ) | const

Gets the current foreground color for the widget's CSS style.

This function should only be used in snapshot implementations that need to do custom drawing with the foreground color.

Since gtkmm 4.10:

Returns
  The widget's foreground color.

## ◆ get_css_classes()

std::vector< Glib::ustring > Gtk::Widget::get_css_classes | ( |  | ) | const

Returns the list of style classes applied to widget.

Returns
  A `nullptr`-terminated list of css classes currently applied to widget.

## ◆ get_css_name()

Glib::ustring Gtk::Widget::get_css_name | ( |  | ) | const

Returns the CSS name that is used for self.

Returns
  The CSS name.

## ◆ get_cursor() [1/2]

Glib::RefPtr< Gdk::Cursor > Gtk::Widget::get_cursor | ( |  | ) |

Queries the cursor set on widget.

See set_cursor() for details.

Returns
  The cursor currently in use or `nullptr` if the cursor is inherited.

## ◆ get_cursor() [2/2]

Glib::RefPtr< const Gdk::Cursor > Gtk::Widget::get_cursor | ( |  | ) | const

Queries the cursor set on widget.

See set_cursor() for details.

Returns
  The cursor currently in use or `nullptr` if the cursor is inherited.

## ◆ get_default_direction()

static TextDirection Gtk::Widget::get_default_direction | ( |  | ) |
| static

Obtains the current default reading direction.

See set_default_direction().

Returns
  The current default direction.

## ◆ get_direction()

TextDirection Gtk::Widget::get_direction | ( |  | ) | const

Gets the reading direction for a particular widget.

See set_direction().

Returns
  The reading direction for the widget.

## ◆ get_display() [1/2]

Glib::RefPtr< Gdk::Display > Gtk::Widget::get_display | ( |  | ) |

Get the `Gdk::Display` for the toplevel window associated with this widget.

This function can only be called after the widget has been added to a widget hierarchy with a `Gtk::Window` at the top.

In general, you should only create display specific resources when a widget has been realized, and you should free those resources when the widget is unrealized.

Returns
  The `Gdk::Display` for the toplevel for this widget.

## ◆ get_display() [2/2]

Glib::RefPtr< const Gdk::Display > Gtk::Widget::get_display | ( |  | ) | const

Get the `Gdk::Display` for the toplevel window associated with this widget.

This function can only be called after the widget has been added to a widget hierarchy with a `Gtk::Window` at the top.

In general, you should only create display specific resources when a widget has been realized, and you should free those resources when the widget is unrealized.

Returns
  The `Gdk::Display` for the toplevel for this widget.

## ◆ get_first_child() [1/2]

Widget * Gtk::Widget::get_first_child | ( |  | ) |

Returns the widget’s first child.

This API is primarily meant for widget implementations.

Returns
  The widget's first child.

## ◆ get_first_child() [2/2]

const Widget * Gtk::Widget::get_first_child | ( |  | ) | const

Returns the widget’s first child.

This API is primarily meant for widget implementations.

Returns
  The widget's first child.

## ◆ get_focus_child() [1/2]

Widget * Gtk::Widget::get_focus_child | ( |  | ) |
| protected

Returns the current focus child of widget.

Returns
  The current focus child of widget.

## ◆ get_focus_child() [2/2]

const Widget * Gtk::Widget::get_focus_child | ( |  | ) | const
| protected

Returns the current focus child of widget.

Returns
  The current focus child of widget.

## ◆ get_focus_on_click()

bool Gtk::Widget::get_focus_on_click | ( |  | ) | const

Returns whether the widget should grab focus when it is clicked with the mouse.

See set_focus_on_click().

Returns
  `true` if the widget should grab focus when it is clicked with the mouse.

## ◆ get_focusable()

bool Gtk::Widget::get_focusable | ( |  | ) | const

Determines whether widget can own the input focus.

See set_focusable().

Returns
  `true` if widget can own the input focus, `false` otherwise.

## ◆ get_font_map() [1/2]

Glib::RefPtr< Pango::FontMap > Gtk::Widget::get_font_map | ( |  | ) |

Gets the font map of widget.

See set_font_map().

Returns
  A `Pango::FontMap`.

## ◆ get_font_map() [2/2]

Glib::RefPtr< const Pango::FontMap > Gtk::Widget::get_font_map | ( |  | ) | const

Gets the font map of widget.

See set_font_map().

Returns
  A `Pango::FontMap`.

## ◆ get_font_options()

Cairo::FontOptions Gtk::Widget::get_font_options | ( |  | ) | const

Returns the `cairo_font_options_t` of widget.

Seee set_font_options().

Deprecated: 4.16

Deprecated:
  There is no replacement.

Returns
  The `cairo_font_options_t` of widget.

## ◆ get_frame_clock() [1/2]

Glib::RefPtr< Gdk::FrameClock > Gtk::Widget::get_frame_clock | ( |  | ) |

Obtains the frame clock for a widget.

The frame clock is a global “ticker” that can be used to drive animations and repaints. The most common reason to get the frame clock is to call Gdk::FrameClock::get_frame_time(), in order to get a time to use for animating. For example you might record the start of the animation with an initial value from Gdk::FrameClock::get_frame_time(), and then update the animation by calling Gdk::FrameClock::get_frame_time() again during each repaint.

Gdk::FrameClock::request_phase() will result in a new frame on the clock, but won’t necessarily repaint any widgets. To repaint a widget, you have to use queue_draw() which invalidates the widget (thus scheduling it to receive a draw on the next frame). queue_draw() will also end up requesting a frame on the appropriate frame clock.

A widget’s frame clock will not change while the widget is mapped. Reparenting a widget (which implies a temporary unmap) can change the widget’s frame clock.

Unrealized widgets do not have a frame clock.

Since gtkmm 3.24:

Returns
  A `Gdk::FrameClock`.

## ◆ get_frame_clock() [2/2]

Glib::RefPtr< const Gdk::FrameClock > Gtk::Widget::get_frame_clock | ( |  | ) | const

Obtains the frame clock for a widget.

The frame clock is a global “ticker” that can be used to drive animations and repaints. The most common reason to get the frame clock is to call Gdk::FrameClock::get_frame_time(), in order to get a time to use for animating. For example you might record the start of the animation with an initial value from Gdk::FrameClock::get_frame_time(), and then update the animation by calling Gdk::FrameClock::get_frame_time() again during each repaint.

Gdk::FrameClock::request_phase() will result in a new frame on the clock, but won’t necessarily repaint any widgets. To repaint a widget, you have to use queue_draw() which invalidates the widget (thus scheduling it to receive a draw on the next frame). queue_draw() will also end up requesting a frame on the appropriate frame clock.

A widget’s frame clock will not change while the widget is mapped. Reparenting a widget (which implies a temporary unmap) can change the widget’s frame clock.

Unrealized widgets do not have a frame clock.

Since gtkmm 3.24:

Returns
  A `Gdk::FrameClock`.

## ◆ get_halign()

Align Gtk::Widget::get_halign | ( |  | ) | const

Gets the horizontal alignment of widget.

For backwards compatibility reasons this method will never return one of the baseline alignments, but instead it will convert it to `Gtk::Align::FILL` or `Gtk::Align::CENTER`.

Baselines are not supported for horizontal alignment.

Returns
  The horizontal alignment of widget.

## ◆ get_has_tooltip()

bool Gtk::Widget::get_has_tooltip | ( |  | ) | const

Returns the current value of the `has-tooltip` property.

Returns
  Current value of `has-tooltip` on widget.

## ◆ get_height()

int Gtk::Widget::get_height | ( |  | ) | const

Returns the content height of the widget.

This function returns the height passed to its size-allocate implementation, which is the height you should be using in snapshot_vfunc().

For pointer events, see contains().

To learn more about widget sizes, see the coordinate system overview.

Returns
  The height of widget.

## ◆ get_hexpand()

bool Gtk::Widget::get_hexpand | ( |  | ) | const

Gets whether the widget would like any available extra horizontal space.

When a user resizes a `Gtk::Window`, widgets with expand=`true` generally receive the extra space. For example, a list or scrollable area or document in your window would often be set to expand.

Containers should use compute_expand() rather than this function, to see whether a widget, or any of its children, has the expand flag set. If any child of a widget wants to expand, the parent may ask to expand also.

This function only looks at the widget’s own hexpand flag, rather than computing whether the entire widget tree rooted at this widget wants to expand.

Returns
  Whether hexpand flag is set.

## ◆ get_hexpand_set()

bool Gtk::Widget::get_hexpand_set | ( |  | ) | const

Gets whether set_hexpand() has been used to explicitly set the expand flag on this widget.

If property_hexpand() property is set, then it overrides any computed expand value based on child widgets. If `hexpand` is not set, then the expand value depends on whether any children of the widget would like to expand.

There are few reasons to use this function, but it’s here for completeness and consistency.

Returns
  Whether hexpand has been explicitly set.

## ◆ get_last_child() [1/2]

Widget * Gtk::Widget::get_last_child | ( |  | ) |

Returns the widget’s last child.

This API is primarily meant for widget implementations.

Returns
  The widget's last child.

## ◆ get_last_child() [2/2]

const Widget * Gtk::Widget::get_last_child | ( |  | ) | const

Returns the widget’s last child.

This API is primarily meant for widget implementations.

Returns
  The widget's last child.

## ◆ get_layout_manager() [1/2]

Glib::RefPtr< LayoutManager > Gtk::Widget::get_layout_manager | ( |  | ) |

Retrieves the layout manager used by widget.

See set_layout_manager().

Returns
  A `Gtk::LayoutManager`.

## ◆ get_layout_manager() [2/2]

Glib::RefPtr< const LayoutManager > Gtk::Widget::get_layout_manager | ( |  | ) | const

Retrieves the layout manager used by widget.

See set_layout_manager().

Returns
  A `Gtk::LayoutManager`.

## ◆ get_mapped()

bool Gtk::Widget::get_mapped | ( |  | ) | const

Whether the widget is mapped.

Returns
  `true` if the widget is mapped, `false` otherwise.

## ◆ get_margin_bottom()

int Gtk::Widget::get_margin_bottom | ( |  | ) | const

Gets the bottom margin of widget.

Returns
  The bottom margin of widget.

## ◆ get_margin_end()

int Gtk::Widget::get_margin_end | ( |  | ) | const

Gets the end margin of widget.

Returns
  The end margin of widget.

## ◆ get_margin_start()

int Gtk::Widget::get_margin_start | ( |  | ) | const

Gets the start margin of widget.

Returns
  The start margin of widget.

## ◆ get_margin_top()

int Gtk::Widget::get_margin_top | ( |  | ) | const

Gets the top margin of widget.

Returns
  The top margin of widget.

## ◆ get_name()

Glib::ustring Gtk::Widget::get_name | ( |  | ) | const

Retrieves the name of a widget.

See set_name() for the significance of widget names.

Returns
  Name of the widget. This string is owned by GTK and should not be modified or freed.

## ◆ get_native() [1/2]

Native * Gtk::Widget::get_native | ( |  | ) |

Returns the nearest `Gtk::Native` ancestor of widget.

This function will return `nullptr` if the widget is not contained inside a widget tree with a native ancestor.

`Gtk::Native` widgets will return themselves here.

Returns
  The `Gtk::Native` ancestor of widget.

## ◆ get_native() [2/2]

const Native * Gtk::Widget::get_native | ( |  | ) | const

Returns the nearest `Gtk::Native` ancestor of widget.

This function will return `nullptr` if the widget is not contained inside a widget tree with a native ancestor.

`Gtk::Native` widgets will return themselves here.

Returns
  The `Gtk::Native` ancestor of widget.

## ◆ get_next_sibling() [1/2]

Widget * Gtk::Widget::get_next_sibling | ( |  | ) |

Returns the widget’s next sibling.

This API is primarily meant for widget implementations.

Returns
  The widget's next sibling.

## ◆ get_next_sibling() [2/2]

const Widget * Gtk::Widget::get_next_sibling | ( |  | ) | const

Returns the widget’s next sibling.

This API is primarily meant for widget implementations.

Returns
  The widget's next sibling.

## ◆ get_opacity()

double Gtk::Widget::get_opacity | ( |  | ) | const

Fetches the requested opacity for this widget.

See set_opacity().

Returns
  The requested opacity for this widget.

## ◆ get_overflow()

Overflow Gtk::Widget::get_overflow | ( |  | ) | const

Returns the widget’s overflow value.

Since gtkmm 3.96:

Returns
  The widget's overflow.

## ◆ get_pango_context()

Glib::RefPtr< Pango::Context > Gtk::Widget::get_pango_context | ( |  | ) |

Gets a `Pango::Context` with the appropriate font map, font description, and base direction for this widget.

Unlike the context returned by create_pango_context(), this context is owned by the widget (it can be used until the screen for the widget changes or the widget is removed from its toplevel), and will be updated to match any changes to the widget’s attributes. This can be tracked by listening to changes of the property_root() property on the widget.

Returns
  The `Pango::Context` for the widget.

## ◆ get_parent() [1/2]

Widget * Gtk::Widget::get_parent | ( |  | ) |

Returns the parent widget of widget.

Returns
  The parent widget of widget.

## ◆ get_parent() [2/2]

const Widget * Gtk::Widget::get_parent | ( |  | ) | const

Returns the parent widget of widget.

Returns
  The parent widget of widget.

## ◆ get_preferred_size() [1/2]

PreferredSize Gtk::Widget::get_preferred_size | ( |  | ) | const

Like the other overload of get_preferred_size() but returns a structure holding the sizes instead of using output parameters.

Since gtkmm 4.14:

## ◆ get_preferred_size() [2/2]

void Gtk::Widget::get_preferred_size | ( | Requisition & | minimum_size,
|  | Requisition & | natural_size
| ) |  | const

Retrieves the minimum and natural size of a widget, taking into account the widget’s preference for height-for-width management.

This is used to retrieve a suitable size by container widgets which do not impose any restrictions on the child placement. It can be used to deduce toplevel window and menu sizes as well as child widgets in free-form containers such as `Gtk::Fixed`.

Handle with care. Note that the natural height of a height-for-width widget will generally be a smaller size than the minimum height, since the required height for the natural width is generally smaller than the required height for the minimum width.

Use measure() if you want to support baseline alignment.

Parameters

  minimum_size | Location for storing the minimum size.
  natural_size | Location for storing the natural size.

## ◆ get_prev_sibling() [1/2]

Widget * Gtk::Widget::get_prev_sibling | ( |  | ) |

Returns the widget’s previous sibling.

This API is primarily meant for widget implementations.

Returns
  The widget's previous sibling.

## ◆ get_prev_sibling() [2/2]

const Widget * Gtk::Widget::get_prev_sibling | ( |  | ) | const

Returns the widget’s previous sibling.

This API is primarily meant for widget implementations.

Returns
  The widget's previous sibling.

## ◆ get_primary_clipboard() [1/2]

Glib::RefPtr< Gdk::Clipboard > Gtk::Widget::get_primary_clipboard | ( |  | ) |

Gets the primary clipboard of widget.

This is a utility function to get the primary clipboard object for the `Gdk::Display` that widget is using.

Note that this function always works, even when widget is not realized yet.

Returns
  The appropriate clipboard object.

## ◆ get_primary_clipboard() [2/2]

Glib::RefPtr< const Gdk::Clipboard > Gtk::Widget::get_primary_clipboard | ( |  | ) | const

Gets the primary clipboard of widget.

This is a utility function to get the primary clipboard object for the `Gdk::Display` that widget is using.

Note that this function always works, even when widget is not realized yet.

Returns
  The appropriate clipboard object.

## ◆ get_realized()

bool Gtk::Widget::get_realized | ( |  | ) | const

Determines whether widget is realized.

Returns
  `true` if widget is realized, `false` otherwise.

## ◆ get_receives_default()

bool Gtk::Widget::get_receives_default | ( |  | ) | const

Determines whether widget is always treated as the default widget within its toplevel when it has the focus, even if another widget is the default.

See set_receives_default().

Returns
  `true` if widget acts as the default widget when focused, `false` otherwise.

## ◆ get_request_mode()

SizeRequestMode Gtk::Widget::get_request_mode | ( |  | ) | const

Gets whether the widget prefers a height-for-width layout or a width-for-height layout.

Single-child widgets generally propagate the preference of their child, more complex widgets need to request something either in context of their children or in context of their allocation capabilities.

Returns
  The `Gtk::SizeRequestMode` preferred by widget.

## ◆ get_request_mode_vfunc()

virtual SizeRequestMode Gtk::Widget::get_request_mode_vfunc | ( |  | ) | const
| protectedvirtual

## ◆ get_root() [1/2]

Root * Gtk::Widget::get_root | ( |  | ) |

Returns the `Gtk::Root` widget of widget.

This function will return `nullptr` if the widget is not contained inside a widget tree with a root widget.

`Gtk::Root` widgets will return themselves here.

Returns
  The root widget of widget.

## ◆ get_root() [2/2]

const Root * Gtk::Widget::get_root | ( |  | ) | const

Returns the `Gtk::Root` widget of widget.

This function will return `nullptr` if the widget is not contained inside a widget tree with a root widget.

`Gtk::Root` widgets will return themselves here.

Returns
  The root widget of widget.

## ◆ get_scale_factor()

int Gtk::Widget::get_scale_factor | ( |  | ) | const

Retrieves the internal scale factor that maps from window coordinates to the actual device pixels.

On traditional systems this is 1, on high density outputs, it can be a higher value (typically 2).

See Gdk::Surface::get_scale_factor().

Returns
  The scale factor for widget.

## ◆ get_sensitive()

bool Gtk::Widget::get_sensitive | ( |  | ) | const

Returns the widget’s sensitivity.

This function returns the value that has been set using set_sensitive()).

The effective sensitivity of a widget is however determined by both its own and its parent widget’s sensitivity. See is_sensitive().

Returns
  `true` if the widget is sensitive.

## ◆ get_settings()

Glib::RefPtr< Settings > Gtk::Widget::get_settings | ( |  | ) |

Gets the settings object holding the settings used for this widget.

Note that this function can only be called when the `Gtk::Widget` is attached to a toplevel, since the settings object is specific to a particular `Gdk::Display`. If you want to monitor the widget for changes in its settings, connect to the `notify::display` signal.

Returns
  The relevant `Gtk::Settings` object.

## ◆ get_size()

int Gtk::Widget::get_size | ( | Orientation | orientation | ) | const

Returns the content width or height of the widget.

Which dimension is returned depends on orientation.

This is equivalent to calling get_width() for Gtk::Orientation::HORIZONTAL or get_height() for Gtk::Orientation::VERTICAL, but can be used when writing orientation-independent code, such as when implementing Gtk::Orientable widgets.

To learn more about widget sizes, see the coordinate system overview.

Parameters

  orientation | The orientation to query.

Returns
  The size of widget in orientation.

## ◆ get_size_request() [1/2]

Requisition Gtk::Widget::get_size_request | ( |  | ) | const

Like the other overload of get_size_request() but returns a structure holding the sizes instead of using output parameters.

Since gtkmm 4.14:

## ◆ get_size_request() [2/2]

void Gtk::Widget::get_size_request | ( | int & | width,
|  | int & | height
| ) |  | const

Gets the size request that was explicitly set for the widget using set_size_request().

A value of -1 stored in width or height indicates that that dimension has not been set explicitly and the natural requisition of the widget will be used instead. See set_size_request(). To get the size a widget will actually request, call measure() instead of this function.

Parameters

  width | Return location for width.
  height | Return location for height.

## ◆ get_state_flags()

StateFlags Gtk::Widget::get_state_flags | ( |  | ) | const

Returns the widget state as a flag set.

It is worth mentioning that the effective Gtk::StateFlags::INSENSITIVE state will be returned, that is, also based on parent insensitivity, even if widget itself is sensitive.

Also note that if you are looking for a way to obtain the Gtk::StateFlags to pass to a Gtk::StyleContext method, you should look at Gtk::StyleContext::get_state().

Returns
  The state flags for widget.

## ◆ get_style_context() [1/2]

Glib::RefPtr< StyleContext > Gtk::Widget::get_style_context | ( |  | ) |

Returns the style context associated to widget.

The returned object is guaranteed to be the same for the lifetime of widget.

Deprecated: 4.10: Style contexts will be removed in GTK 5

Deprecated:
  Style contexts will be removed in GTK 5.

Returns
  The widget’s `Gtk::StyleContext`.

## ◆ get_style_context() [2/2]

Glib::RefPtr< const StyleContext > Gtk::Widget::get_style_context | ( |  | ) | const

Returns the style context associated to widget.

The returned object is guaranteed to be the same for the lifetime of widget.

Deprecated: 4.10: Style contexts will be removed in GTK 5

Deprecated:
  Style contexts will be removed in GTK 5.

Returns
  The widget’s `Gtk::StyleContext`.

## ◆ get_tooltip_markup()

Glib::ustring Gtk::Widget::get_tooltip_markup | ( |  | ) | const

Gets the contents of the tooltip for widget.

If the tooltip has not been set using set_tooltip_markup(), this function returns `nullptr`.

Returns
  The tooltip text.

## ◆ get_tooltip_text()

Glib::ustring Gtk::Widget::get_tooltip_text | ( |  | ) | const

Gets the contents of the tooltip for widget.

If the widget's tooltip was set using set_tooltip_markup(), this function will return the escaped text.

Returns
  The tooltip text.

## ◆ get_type()

static GType Gtk::Widget::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ get_valign()

Align Gtk::Widget::get_valign | ( |  | ) | const

Gets the vertical alignment of widget.

Returns
  The vertical alignment of widget.

## ◆ get_vexpand()

bool Gtk::Widget::get_vexpand | ( |  | ) | const

Gets whether the widget would like any available extra vertical space.

See get_hexpand() for more detail.

Returns
  Whether vexpand flag is set.

## ◆ get_vexpand_set()

bool Gtk::Widget::get_vexpand_set | ( |  | ) | const

Gets whether set_vexpand() has been used to explicitly set the expand flag on this widget.

See get_hexpand_set() for more detail.

Returns
  Whether vexpand has been explicitly set.

## ◆ get_visible()

bool Gtk::Widget::get_visible | ( |  | ) | const

Determines whether the widget is visible.

If you want to take into account whether the widget’s parent is also marked as visible, use is_visible() instead.

This function does not check if the widget is obscured in any way.

See set_visible().

Returns
  `true` if the widget is visible.

## ◆ get_width()

int Gtk::Widget::get_width | ( |  | ) | const

Returns the content width of the widget.

This function returns the width passed to its size-allocate implementation, which is the width you should be using in snapshot_vfunc().

For pointer events, see contains().

To learn more about widget sizes, see the coordinate system overview.

Returns
  The width of widget.

## ◆ gobj() [1/2]

GtkWidget * Gtk::Widget::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkWidget * Gtk::Widget::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ grab_focus()

bool Gtk::Widget::grab_focus | ( |  | ) |

Causes widget to have the keyboard focus for the `Gtk::Window` it's inside.

If widget is not focusable, or its grab_focus_vfunc() implementation cannot transfer the focus to a descendant of widget that is focusable, it will not take focus and `false` will be returned.

Calling grab_focus() on an already focused widget is allowed, should not have an effect, and return `true`.

Returns
  `true` if focus is now inside widget.

## ◆ grab_focus_vfunc()

virtual bool Gtk::Widget::grab_focus_vfunc | ( |  | ) |
| protectedvirtual

## ◆ has_css_class()

bool Gtk::Widget::has_css_class | ( | const Glib::ustring & | css_class | ) | const

Returns whether css_class is currently applied to widget.

Parameters

  css_class | A style class, without the leading '.' used for notation of style classes.

Returns
  `true` if css_class is currently applied to widget, `false` otherwise.

## ◆ has_default()

bool Gtk::Widget::has_default | ( |  | ) | const

Determines whether widget is the current default widget within its toplevel.

Returns
  `true` if widget is the current default widget within its toplevel, `false` otherwise.

## ◆ has_focus()

bool Gtk::Widget::has_focus | ( |  | ) | const

Determines if the widget has the global input focus.

See is_focus() for the difference between having the global input focus, and only having the focus within a toplevel.

Returns
  `true` if the widget has the global input focus.

## ◆ has_visible_focus()

bool Gtk::Widget::has_visible_focus | ( |  | ) | const

Determines if the widget should show a visible indication that it has the global input focus.

This is a convenience function that takes into account whether focus indication should currently be shown in the toplevel window of widget. See Gtk::Window::get_focus_visible() for more information about focus indication.

To find out if the widget has the global input focus, use has_focus().

Returns
  `true` if the widget should display a “focus rectangle”.

## ◆ hide()

void Gtk::Widget::hide | ( |  | ) |

Reverses the effects of show().

This is causing the widget to be hidden (invisible to the user).

Deprecated: 4.10: Use set_visible() instead

Deprecated:
  Use set_visible() instead.

## ◆ in_destruction()

bool Gtk::Widget::in_destruction | ( |  | ) | const

Returns whether the widget is currently being destroyed.

This information can sometimes be used to avoid doing unnecessary work.

Returns
  `true` if widget is being destroyed.

## ◆ insert_action_group()

void Gtk::Widget::insert_action_group | ( | const Glib::ustring & | name,
|  | const Glib::RefPtr< Gio::ActionGroup > & | group
| ) |  |

Inserts group into widget.

Children of widget that implement Gtk::Actionable can then be associated with actions in group by setting their “action-name” to prefix.`action-name`.

Note that inheritance is defined for individual actions. I.e. even if you insert a group with prefix prefix, actions with the same prefix will still be inherited from the parent, unless the group contains an action with the same name.

If group is `nullptr`, a previously inserted group for name is removed from widget.

Parameters

  name | The prefix for actions in group.
  group | A `Gio::ActionGroup`, or `nullptr` to remove the previously inserted group for name.

## ◆ insert_after()

void Gtk::Widget::insert_after | ( | Widget & | parent,
|  | const Widget & | previous_sibling
| ) |  |

Inserts the Widget into the child widget list of parent after previous_sibling.

After calling this function, get_prev_sibling() will return previous_sibling.

If parent is already set as the parent widget of the Widget, this function can also be used to reorder the Widget in the child widget list of parent.

Parameters

  parent | The parent Gtk::Widget to insert the Widget into.
  previous_sibling | The new previous sibling of the Widget.

## ◆ insert_at_end()

void Gtk::Widget::insert_at_end | ( | Widget & | parent | ) |

Inserts the Widget at the end of the child widget list of parent.

After calling this function, get_next_sibling() will return `nullptr`.

If parent is already set as the parent of the Widget, this function can also be used to reorder the Widget in the child widget list of parent.

Parameters

  parent | The parent Gtk::Widget to insert the Widget into.

## ◆ insert_at_start()

void Gtk::Widget::insert_at_start | ( | Widget & | parent | ) |

Inserts the Widget at the beginning of the child widget list of parent.

After calling this function, get_prev_sibling() will return `nullptr`.

If parent is already set as the parent of the Widget, this function can also be used to reorder the Widget in the child widget list of parent.

Parameters

  parent | The parent Gtk::Widget to insert the Widget into.

## ◆ insert_before()

void Gtk::Widget::insert_before | ( | Widget & | parent,
|  | const Widget & | next_sibling
| ) |  |

Inserts the Widget into the child widget list of parent before next_sibling.

After calling this function, get_next_sibling() will return next_sibling.

If parent is already set as the parent widget of the Widget, this function can also be used to reorder the Widget in the child widget list of parent.

Parameters

  parent | The parent Gtk::Widget to insert the Widget into.
  next_sibling | The new next sibling of the Widget.

## ◆ is_ancestor()

bool Gtk::Widget::is_ancestor | ( | Widget & | ancestor | ) | const

Determines whether widget is somewhere inside ancestor, possibly with intermediate containers.

Parameters

  ancestor | Another `Gtk::Widget`.

Returns
  `true` if ancestor contains widget as a child, grandchild, great grandchild, etc.

## ◆ is_drawable()

bool Gtk::Widget::is_drawable | ( |  | ) | const

Determines whether widget can be drawn to.

A widget can be drawn if it is mapped and visible.

Returns
  `true` if widget is drawable, `false` otherwise.

## ◆ is_focus()

bool Gtk::Widget::is_focus | ( |  | ) | const

Determines if the widget is the focus widget within its toplevel.

This does not mean that the property_has_focus() property is necessarily set; property_has_focus() will only be set if the toplevel widget additionally has the global input focus.

Returns
  `true` if the widget is the focus widget.

## ◆ is_sensitive()

bool Gtk::Widget::is_sensitive | ( |  | ) | const

Returns the widget’s effective sensitivity.

This means it is sensitive itself and also its parent widget is sensitive.

Returns
  `true` if the widget is effectively sensitive.

## ◆ is_visible()

bool Gtk::Widget::is_visible | ( |  | ) | const

Determines whether the widget and all its parents are marked as visible.

This function does not check if the widget is obscured in any way.

See also get_visible() and set_visible().

Returns
  `true` if the widget and all its parents are visible.

## ◆ keynav_failed()

bool Gtk::Widget::keynav_failed | ( | DirectionType | direction | ) |

Emits the `keynav-failed` signal on the widget.

This function should be called whenever keyboard navigation within a single widget hits a boundary.

The return value of this function should be interpreted in a way similar to the return value of child_focus(). When `true` is returned, stay in the widget, the failed keyboard navigation is OK and/or there is nowhere we can/should move the focus to. When `false` is returned, the caller should continue with keyboard navigation outside the widget, e.g. by calling child_focus() on the widget’s toplevel.

The default signal_keynav_failed() handler returns `false` for Gtk::DirectionType::TAB_FORWARD and Gtk::DirectionType::TAB_BACKWARD. For the other values of `Gtk::DirectionType` it returns `true`.

Whenever the default handler returns `true`, it also calls error_bell() to notify the user of the failed keyboard navigation.

A use case for providing an own implementation of signal_keynav_failed() (either by connecting to it or by overriding it) would be a row of Gtk::Entry widgets where the user should be able to navigate the entire row with the cursor keys, as e.g. known from user interfaces that require entering license keys.

Parameters

  direction | Direction of focus movement.

Returns
  `true` if stopping keyboard navigation is fine, `false` if the emitting widget should try to handle the keyboard navigation attempt in its parent container(s).

## ◆ list_mnemonic_labels() [1/2]

std::vector< Widget * > Gtk::Widget::list_mnemonic_labels | ( |  | ) |

Returns the widgets for which this widget is the target of a mnemonic.

Typically, these widgets will be labels. See, for example, Gtk::Label::set_mnemonic_widget().

The widgets in the list are not individually referenced. If you want to iterate through the list and perform actions involving callbacks that might destroy the widgets, you must call `g_list_foreach (result, (GFunc)g_object_ref, <tt>nullptr</tt>)` first, and then unref all the widgets afterwards.

Returns
  The list of mnemonic labels; free this list with Glib::list_free() when you are done with it.

## ◆ list_mnemonic_labels() [2/2]

std::vector< const Widget * > Gtk::Widget::list_mnemonic_labels | ( |  | ) | const

Returns the widgets for which this widget is the target of a mnemonic.

Typically, these widgets will be labels. See, for example, Gtk::Label::set_mnemonic_widget().

The widgets in the list are not individually referenced. If you want to iterate through the list and perform actions involving callbacks that might destroy the widgets, you must call `g_list_foreach (result, (GFunc)g_object_ref, <tt>nullptr</tt>)` first, and then unref all the widgets afterwards.

Returns
  The list of mnemonic labels; free this list with Glib::list_free() when you are done with it.

## ◆ make_refptr_constrainttarget() [1/2]

Glib::RefPtr< ConstraintTarget > Gtk::Widget::make_refptr_constrainttarget | ( |  | ) |

Converts this widget to a reference counted Gtk::ConstraintTarget.

Useful in calls to Gtk::Constraint::create().

## ◆ make_refptr_constrainttarget() [2/2]

Glib::RefPtr< const ConstraintTarget > Gtk::Widget::make_refptr_constrainttarget | ( |  | ) | const

Converts this widget to a reference counted Gtk::ConstraintTarget.

## ◆ map()

void Gtk::Widget::map | ( |  | ) |

Causes a widget to be mapped if it isn’t already.

This function is only for use in widget implementations.

## ◆ measure() [1/2]

void Gtk::Widget::measure | ( | Orientation | orientation,
|  | int | for_size,
|  | int & | minimum,
|  | int & | natural,
|  | int & | minimum_baseline,
|  | int & | natural_baseline
| ) |  | const

Measures widget in the orientation orientation and for the given for_size.

As an example, if orientation is Gtk::Orientation::HORIZONTAL and for_size is 300, this functions will compute the minimum and natural width of widget if it is allocated at a height of 300 pixels.

See GtkWidget’s geometry management section for a more details on implementing `GtkWidgetClass.measure()`.

Parameters

  orientation | The orientation to measure.
  for_size | Size for the opposite of orientation, i.e. if orientation is Gtk::Orientation::HORIZONTAL, this is the height the widget should be measured with. The Gtk::Orientation::VERTICAL case is analogous. This way, both height-for-width and width-for-height requests can be implemented. If no size is known, -1 can be passed.
  minimum | Location to store the minimum size.
  natural | Location to store the natural size.
  minimum_baseline | Location to store the baseline position for the minimum size, or -1 to report no baseline.
  natural_baseline | Location to store the baseline position for the natural size, or -1 to report no baseline.

## ◆ measure() [2/2]

Measurements Gtk::Widget::measure | ( | Orientation | orientation,
|  | int | for_size = `-1`
| ) |  | const

Like the other overload of measure() but returns a structure holding the sizes/baselines instead of using output parameters.

Since gtkmm 4.14:

## ◆ measure_vfunc()

virtual void Gtk::Widget::measure_vfunc | ( | Orientation | orientation,
|  | int | for_size,
|  | int & | minimum,
|  | int & | natural,
|  | int & | minimum_baseline,
|  | int & | natural_baseline
| ) |  | const
| protectedvirtual

## ◆ mnemonic_activate()

bool Gtk::Widget::mnemonic_activate | ( | bool | group_cycling | ) |

Emits the signal_mnemonic_activate() signal.

See signal_mnemonic_activate().

Parameters

  group_cycling | `true` if there are other widgets with the same mnemonic.

Returns
  `true` if the signal has been handled.

## ◆ observe_children() [1/2]

Glib::RefPtr< Gio::ListModel > Gtk::Widget::observe_children | ( |  | ) |

Returns a `Gio::ListModel` to track the children of widget.

Calling this function will enable extra internal bookkeeping to track children and emit signals on the returned listmodel. It may slow down operations a lot.

Applications should try hard to avoid calling this function because of the slowdowns.

Returns
  A `Gio::ListModel` tracking widget's children.

## ◆ observe_children() [2/2]

Glib::RefPtr< const Gio::ListModel > Gtk::Widget::observe_children | ( |  | ) | const

Returns a `Gio::ListModel` to track the children of widget.

Calling this function will enable extra internal bookkeeping to track children and emit signals on the returned listmodel. It may slow down operations a lot.

Applications should try hard to avoid calling this function because of the slowdowns.

Returns
  A `Gio::ListModel` tracking widget's children.

## ◆ observe_controllers() [1/2]

Glib::RefPtr< Gio::ListModel > Gtk::Widget::observe_controllers | ( |  | ) |

Returns a `Gio::ListModel` to track the Gtk::EventControllers of widget.

Calling this function will enable extra internal bookkeeping to track controllers and emit signals on the returned listmodel. It may slow down operations a lot.

Applications should try hard to avoid calling this function because of the slowdowns.

Returns
  A `Gio::ListModel` tracking widget's controllers.

## ◆ observe_controllers() [2/2]

Glib::RefPtr< const Gio::ListModel > Gtk::Widget::observe_controllers | ( |  | ) | const

Returns a `Gio::ListModel` to track the Gtk::EventControllers of widget.

Calling this function will enable extra internal bookkeeping to track controllers and emit signals on the returned listmodel. It may slow down operations a lot.

Applications should try hard to avoid calling this function because of the slowdowns.

Returns
  A `Gio::ListModel` tracking widget's controllers.

## ◆ on_direction_changed()

virtual void Gtk::Widget::on_direction_changed | ( | TextDirection | direction | ) |
| protectedvirtual

This is a default handler for the signal signal_direction_changed().

## ◆ on_hide()

virtual void Gtk::Widget::on_hide | ( |  | ) |
| protectedvirtual

This is a default handler for the signal signal_hide().

## ◆ on_map()

virtual void Gtk::Widget::on_map | ( |  | ) |
| protectedvirtual

This is a default handler for the signal signal_map().

## ◆ on_mnemonic_activate()

virtual bool Gtk::Widget::on_mnemonic_activate | ( | bool | group_cycling | ) |
| protectedvirtual

This is a default handler for the signal signal_mnemonic_activate().

## ◆ on_query_tooltip()

virtual bool Gtk::Widget::on_query_tooltip | ( | int | x,
|  | int | y,
|  | bool | keyboard_tooltip,
|  | const Glib::RefPtr< Tooltip > & | tooltip
| ) |  |
| protectedvirtual

This is a default handler for the signal signal_query_tooltip().

## ◆ on_realize()

virtual void Gtk::Widget::on_realize | ( |  | ) |
| protectedvirtual

This is a default handler for the signal signal_realize().

## ◆ on_show()

virtual void Gtk::Widget::on_show | ( |  | ) |
| protectedvirtual

This is a default handler for the signal signal_show().

## ◆ on_state_flags_changed()

virtual void Gtk::Widget::on_state_flags_changed | ( | Gtk::StateFlags | previous_state_flags | ) |
| protectedvirtual

This is a default handler for the signal signal_state_flags_changed().

## ◆ on_unmap()

virtual void Gtk::Widget::on_unmap | ( |  | ) |
| protectedvirtual

This is a default handler for the signal signal_unmap().

## ◆ on_unrealize()

virtual void Gtk::Widget::on_unrealize | ( |  | ) |
| protectedvirtual

This is a default handler for the signal signal_unrealize().

## ◆ operator=() [1/2]

Widget & Gtk::Widget::operator= | ( | const Widget & |  | ) |
| delete

## ◆ operator=() [2/2]

Widget & Gtk::Widget::operator= | ( | Widget && | src | ) |
| noexcept

## ◆ pick() [1/2]

Widget * Gtk::Widget::pick | ( | double | x,
|  | double | y,
|  | PickFlags | flags = `PickFlags::DEFAULT`
| ) |  |

Finds the descendant of widget closest to the point ( x, y).

The point must be given in widget coordinates, so (0, 0) is assumed to be the top left of widget's content area.

Usually widgets will return `nullptr` if the given coordinate is not contained in widget checked via contains(). Otherwise they will recursively try to find a child that does not return `nullptr`. Widgets are however free to customize their picking algorithm.

This function is used on the toplevel to determine the widget below the mouse cursor for purposes of hover highlighting and delivering events.

Parameters

  x | X coordinate to test, relative to widget's origin.
  y | Y coordinate to test, relative to widget's origin.
  flags | Flags to influence what is picked.

Returns
  The widget descendant at the given point.

## ◆ pick() [2/2]

const Widget * Gtk::Widget::pick | ( | double | x,
|  | double | y,
|  | PickFlags | flags = `PickFlags::DEFAULT`
| ) |  | const

Finds the descendant of widget closest to the point ( x, y).

The point must be given in widget coordinates, so (0, 0) is assumed to be the top left of widget's content area.

Usually widgets will return `nullptr` if the given coordinate is not contained in widget checked via contains(). Otherwise they will recursively try to find a child that does not return `nullptr`. Widgets are however free to customize their picking algorithm.

This function is used on the toplevel to determine the widget below the mouse cursor for purposes of hover highlighting and delivering events.

Parameters

  x | X coordinate to test, relative to widget's origin.
  y | Y coordinate to test, relative to widget's origin.
  flags | Flags to influence what is picked.

Returns
  The widget descendant at the given point.

## ◆ property_can_focus() [1/2]

Glib::PropertyProxy< bool > Gtk::Widget::property_can_focus | ( |  | ) |

Whether the widget or any of its descendents can accept the input focus.

This property is meant to be set by widget implementations, typically in their instance init function.

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_can_focus() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_can_focus | ( |  | ) | const

Whether the widget or any of its descendents can accept the input focus.

This property is meant to be set by widget implementations, typically in their instance init function.

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_can_target() [1/2]

Glib::PropertyProxy< bool > Gtk::Widget::property_can_target | ( |  | ) |

Whether the widget can receive pointer events.

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_can_target() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_can_target | ( |  | ) | const

Whether the widget can receive pointer events.

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_css_classes() [1/2]

Glib::PropertyProxy< std::vector< Glib::ustring > > Gtk::Widget::property_css_classes | ( |  | ) |

A list of css classes applied to this widget.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_css_classes() [2/2]

Glib::PropertyProxy_ReadOnly< std::vector< Glib::ustring > > Gtk::Widget::property_css_classes | ( |  | ) | const

A list of css classes applied to this widget.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_css_name()

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::Widget::property_css_name | ( |  | ) | const

The name of this widget in the CSS tree.

This property is meant to be set by widget implementations, typically in their instance init function.

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_cursor() [1/2]

Glib::PropertyProxy< Glib::RefPtr< Gdk::Cursor > > Gtk::Widget::property_cursor | ( |  | ) |

The cursor used by widget.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_cursor() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Cursor > > Gtk::Widget::property_cursor | ( |  | ) | const

The cursor used by widget.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_focus_on_click() [1/2]

Glib::PropertyProxy< bool > Gtk::Widget::property_focus_on_click | ( |  | ) |

Whether the widget should grab focus when it is clicked with the mouse.

This property is only relevant for widgets that can take focus.

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_focus_on_click() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_focus_on_click | ( |  | ) | const

Whether the widget should grab focus when it is clicked with the mouse.

This property is only relevant for widgets that can take focus.

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_focusable() [1/2]

Glib::PropertyProxy< bool > Gtk::Widget::property_focusable | ( |  | ) |

Whether this widget itself will accept the input focus.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_focusable() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_focusable | ( |  | ) | const

Whether this widget itself will accept the input focus.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_halign() [1/2]

Glib::PropertyProxy< Align > Gtk::Widget::property_halign | ( |  | ) |

How to distribute horizontal space if widget gets extra space.

Default value: Gtk::Align::FILL

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_halign() [2/2]

Glib::PropertyProxy_ReadOnly< Align > Gtk::Widget::property_halign | ( |  | ) | const

How to distribute horizontal space if widget gets extra space.

Default value: Gtk::Align::FILL

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_has_default()

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_has_default | ( |  | ) | const

Whether the widget is the default widget.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_has_focus()

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_has_focus | ( |  | ) | const

Whether the widget has the input focus.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_has_tooltip() [1/2]

Glib::PropertyProxy< bool > Gtk::Widget::property_has_tooltip | ( |  | ) |

Enables or disables the emission of the signal_query_tooltip() signal on widget.

A value of `true` indicates that widget can have a tooltip, in this case the widget will be queried using signal_query_tooltip() to determine whether it will provide a tooltip or not.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_has_tooltip() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_has_tooltip | ( |  | ) | const

Enables or disables the emission of the signal_query_tooltip() signal on widget.

A value of `true` indicates that widget can have a tooltip, in this case the widget will be queried using signal_query_tooltip() to determine whether it will provide a tooltip or not.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_height_request() [1/2]

Glib::PropertyProxy< int > Gtk::Widget::property_height_request | ( |  | ) |

Override for height request of the widget.

If this is -1, the natural request will be used.

Default value: -1

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_height_request() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::Widget::property_height_request | ( |  | ) | const

Override for height request of the widget.

If this is -1, the natural request will be used.

Default value: -1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_hexpand() [1/2]

Glib::PropertyProxy< bool > Gtk::Widget::property_hexpand | ( |  | ) |

Whether to expand horizontally.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_hexpand() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_hexpand | ( |  | ) | const

Whether to expand horizontally.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_hexpand_set() [1/2]

Glib::PropertyProxy< bool > Gtk::Widget::property_hexpand_set | ( |  | ) |

Whether to use the `hexpand` property.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_hexpand_set() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_hexpand_set | ( |  | ) | const

Whether to use the `hexpand` property.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_layout_manager() [1/2]

Glib::PropertyProxy< Glib::RefPtr< LayoutManager > > Gtk::Widget::property_layout_manager | ( |  | ) |

The `Gtk::LayoutManager` instance to use to compute the preferred size of the widget, and allocate its children.

This property is meant to be set by widget implementations, typically in their instance init function.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_layout_manager() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< LayoutManager > > Gtk::Widget::property_layout_manager | ( |  | ) | const

The `Gtk::LayoutManager` instance to use to compute the preferred size of the widget, and allocate its children.

This property is meant to be set by widget implementations, typically in their instance init function.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_margin_bottom() [1/2]

Glib::PropertyProxy< int > Gtk::Widget::property_margin_bottom | ( |  | ) |

Margin on bottom side of widget.

This property adds margin outside of the widget's normal size request, the margin will be added in addition to the size from Gtk::Widget::set_size_request() for example.

Default value: 0

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_margin_bottom() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::Widget::property_margin_bottom | ( |  | ) | const

Margin on bottom side of widget.

This property adds margin outside of the widget's normal size request, the margin will be added in addition to the size from Gtk::Widget::set_size_request() for example.

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_margin_end() [1/2]

Glib::PropertyProxy< int > Gtk::Widget::property_margin_end | ( |  | ) |

Margin on end of widget, horizontally.

This property supports left-to-right and right-to-left text directions.

This property adds margin outside of the widget's normal size request, the margin will be added in addition to the size from Gtk::Widget::set_size_request() for example.

Default value: 0

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_margin_end() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::Widget::property_margin_end | ( |  | ) | const

Margin on end of widget, horizontally.

This property supports left-to-right and right-to-left text directions.

This property adds margin outside of the widget's normal size request, the margin will be added in addition to the size from Gtk::Widget::set_size_request() for example.

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_margin_start() [1/2]

Glib::PropertyProxy< int > Gtk::Widget::property_margin_start | ( |  | ) |

Margin on start of widget, horizontally.

This property supports left-to-right and right-to-left text directions.

This property adds margin outside of the widget's normal size request, the margin will be added in addition to the size from Gtk::Widget::set_size_request() for example.

Default value: 0

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_margin_start() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::Widget::property_margin_start | ( |  | ) | const

Margin on start of widget, horizontally.

This property supports left-to-right and right-to-left text directions.

This property adds margin outside of the widget's normal size request, the margin will be added in addition to the size from Gtk::Widget::set_size_request() for example.

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_margin_top() [1/2]

Glib::PropertyProxy< int > Gtk::Widget::property_margin_top | ( |  | ) |

Margin on top side of widget.

This property adds margin outside of the widget's normal size request, the margin will be added in addition to the size from Gtk::Widget::set_size_request() for example.

Default value: 0

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_margin_top() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::Widget::property_margin_top | ( |  | ) | const

Margin on top side of widget.

This property adds margin outside of the widget's normal size request, the margin will be added in addition to the size from Gtk::Widget::set_size_request() for example.

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_name() [1/2]

Glib::PropertyProxy< Glib::ustring > Gtk::Widget::property_name | ( |  | ) |

The name of the widget.

Default value: ""

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_name() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::Widget::property_name | ( |  | ) | const

The name of the widget.

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_opacity() [1/2]

Glib::PropertyProxy< double > Gtk::Widget::property_opacity | ( |  | ) |

The requested opacity of the widget.

Default value: 1

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_opacity() [2/2]

Glib::PropertyProxy_ReadOnly< double > Gtk::Widget::property_opacity | ( |  | ) | const

The requested opacity of the widget.

Default value: 1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_overflow() [1/2]

Glib::PropertyProxy< Overflow > Gtk::Widget::property_overflow | ( |  | ) |

How content outside the widget's content area is treated.

This property is meant to be set by widget implementations, typically in their instance init function.

Since gtkmm 3.96:

Default value: Gtk::Overflow::VISIBLE

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_overflow() [2/2]

Glib::PropertyProxy_ReadOnly< Overflow > Gtk::Widget::property_overflow | ( |  | ) | const

How content outside the widget's content area is treated.

This property is meant to be set by widget implementations, typically in their instance init function.

Since gtkmm 3.96:

Default value: Gtk::Overflow::VISIBLE

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_parent()

Glib::PropertyProxy_ReadOnly< Widget * > Gtk::Widget::property_parent | ( |  | ) | const

The parent widget of this widget.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_receives_default() [1/2]

Glib::PropertyProxy< bool > Gtk::Widget::property_receives_default | ( |  | ) |

Whether the widget will receive the default action when it is focused.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_receives_default() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_receives_default | ( |  | ) | const

Whether the widget will receive the default action when it is focused.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_root()

Glib::PropertyProxy_ReadOnly< Root * > Gtk::Widget::property_root | ( |  | ) | const

The `Gtk::Root` widget of the widget tree containing this widget.

This will be `nullptr` if the widget is not contained in a root widget.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_scale_factor()

Glib::PropertyProxy_ReadOnly< int > Gtk::Widget::property_scale_factor | ( |  | ) | const

The scale factor of the widget.

Default value: 1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_sensitive() [1/2]

Glib::PropertyProxy< bool > Gtk::Widget::property_sensitive | ( |  | ) |

Whether the widget responds to input.

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_sensitive() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_sensitive | ( |  | ) | const

Whether the widget responds to input.

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_tooltip_markup() [1/2]

Glib::PropertyProxy< Glib::ustring > Gtk::Widget::property_tooltip_markup | ( |  | ) |

Sets the text of tooltip to be the given string, which is marked up with Pango markup.

Also see Gtk::Tooltip::set_markup().

This is a convenience property which will take care of getting the tooltip shown if the given string is not `nullptr`: property_has_tooltip() will automatically be set to `true` and there will be taken care of signal_query_tooltip() in the default signal handler.

Note that if both property_tooltip_text() and property_tooltip_markup() are set, the last one wins.

Default value: ""

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_tooltip_markup() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::Widget::property_tooltip_markup | ( |  | ) | const

Sets the text of tooltip to be the given string, which is marked up with Pango markup.

Also see Gtk::Tooltip::set_markup().

This is a convenience property which will take care of getting the tooltip shown if the given string is not `nullptr`: property_has_tooltip() will automatically be set to `true` and there will be taken care of signal_query_tooltip() in the default signal handler.

Note that if both property_tooltip_text() and property_tooltip_markup() are set, the last one wins.

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_tooltip_text() [1/2]

Glib::PropertyProxy< Glib::ustring > Gtk::Widget::property_tooltip_text | ( |  | ) |

Sets the text of tooltip to be the given string.

Also see Gtk::Tooltip::set_text().

This is a convenience property which will take care of getting the tooltip shown if the given string is not `nullptr`: property_has_tooltip() will automatically be set to `true` and there will be taken care of signal_query_tooltip() in the default signal handler.

Note that if both property_tooltip_text() and property_tooltip_markup() are set, the last one wins.

Default value: ""

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_tooltip_text() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::Widget::property_tooltip_text | ( |  | ) | const

Sets the text of tooltip to be the given string.

Also see Gtk::Tooltip::set_text().

This is a convenience property which will take care of getting the tooltip shown if the given string is not `nullptr`: property_has_tooltip() will automatically be set to `true` and there will be taken care of signal_query_tooltip() in the default signal handler.

Note that if both property_tooltip_text() and property_tooltip_markup() are set, the last one wins.

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_valign() [1/2]

Glib::PropertyProxy< Align > Gtk::Widget::property_valign | ( |  | ) |

How to distribute vertical space if widget gets extra space.

Default value: Gtk::Align::FILL

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_valign() [2/2]

Glib::PropertyProxy_ReadOnly< Align > Gtk::Widget::property_valign | ( |  | ) | const

How to distribute vertical space if widget gets extra space.

Default value: Gtk::Align::FILL

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_vexpand() [1/2]

Glib::PropertyProxy< bool > Gtk::Widget::property_vexpand | ( |  | ) |

Whether to expand vertically.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_vexpand() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_vexpand | ( |  | ) | const

Whether to expand vertically.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_vexpand_set() [1/2]

Glib::PropertyProxy< bool > Gtk::Widget::property_vexpand_set | ( |  | ) |

Whether to use the `vexpand` property.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_vexpand_set() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_vexpand_set | ( |  | ) | const

Whether to use the `vexpand` property.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_visible() [1/2]

Glib::PropertyProxy< bool > Gtk::Widget::property_visible | ( |  | ) |

Whether the widget is visible.

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_visible() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_visible | ( |  | ) | const

Whether the widget is visible.

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_width_request() [1/2]

Glib::PropertyProxy< int > Gtk::Widget::property_width_request | ( |  | ) |

Override for width request of the widget.

If this is -1, the natural request will be used.

Default value: -1

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_width_request() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::Widget::property_width_request | ( |  | ) | const

Override for width request of the widget.

If this is -1, the natural request will be used.

Default value: -1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ queue_allocate()

void Gtk::Widget::queue_allocate | ( |  | ) |

Flags the widget for a rerun of the size_allocate_vfunc() function.

Use this function instead of queue_resize() when the widget's size request didn't change but it wants to reposition its contents.

An example user of this function is set_halign().

This function is only for use in widget implementations.

## ◆ queue_draw()

void Gtk::Widget::queue_draw | ( |  | ) |

Schedules this widget to be redrawn in the paint phase of the current or the next frame.

This means widget's snapshot_vfunc() implementation will be called.

## ◆ queue_resize()

void Gtk::Widget::queue_resize | ( |  | ) |

Flags a widget to have its size renegotiated.

This should be called when a widget for some reason has a new size request. For example, when you change the text in a Gtk::Label, the label queues a resize to ensure there’s enough space for the new text.

Note that you cannot call queue_resize() on a widget from inside its implementation of the size_allocate_vfunc() virtual method. Calls to queue_resize() from inside size_allocate_vfunc() will be silently ignored.

This function is only for use in widget implementations.

## ◆ realize()

void Gtk::Widget::realize | ( |  | ) |
| protected

Creates the GDK resources associated with a widget.

Normally realization happens implicitly; if you show a widget and all its parent containers, then the widget will be realized and mapped automatically.

Realizing a widget requires all the widget’s parent widgets to be realized; calling this function realizes the widget’s parents in addition to widget itself. If a widget is not yet inside a toplevel window when you realize it, bad things will happen.

This function is primarily used in widget implementations, and isn’t very useful otherwise. Many times when you think you might need it, a better approach is to connect to a signal that will be called after the widget is realized automatically, such as signal_realize().

## ◆ realize_if_needed()

void Gtk::Widget::realize_if_needed | ( |  | ) |
| protected

## ◆ remove_action_group()

void Gtk::Widget::remove_action_group | ( | const Glib::ustring & | name | ) |

Removes a group from the widget.

See insert_action_group().

Parameters

  name | The prefix for actions.

Since gtkmm 3.10:

## ◆ remove_controller()

void Gtk::Widget::remove_controller | ( | const Glib::RefPtr< EventController > & | controller | ) |

Removes controller from widget, so that it doesn't process events anymore.

It should not be used again.

Widgets will remove all event controllers automatically when they are destroyed, there is normally no need to call this function.

Parameters

  controller | A `Gtk::EventController`.

## ◆ remove_css_class()

void Gtk::Widget::remove_css_class | ( | const Glib::ustring & | css_class | ) |

Removes a style from widget.

After this, the style of widget will stop matching for css_class.

Parameters

  css_class | The style class to remove from widget, without the leading '.' used for notation of style classes.

## ◆ remove_mnemonic_label()

void Gtk::Widget::remove_mnemonic_label | ( | Widget & | label | ) |

Removes a widget from the list of mnemonic labels for this widget.

See list_mnemonic_labels(). The widget must have previously been added to the list with add_mnemonic_label().

Parameters

  label | A `Gtk::Widget` that was previously set as a mnemonic label for widget with add_mnemonic_label().

## ◆ remove_tick_callback()

void Gtk::Widget::remove_tick_callback | ( | guint | id | ) |

Removes a tick callback previously registered with add_tick_callback().

Since gtkmm 3.24:

Parameters

  id | An id returned by add_tick_callback().

## ◆ root_vfunc()

virtual void Gtk::Widget::root_vfunc | ( |  | ) |
| protectedvirtual

## ◆ set_can_focus()

void Gtk::Widget::set_can_focus | ( | bool | can_focus = `true` | ) |

Specifies whether the input focus can enter the widget or any of its children.

Applications should set can_focus to `false` to mark a widget as for pointer/touch use only.

Note that having can_focus be `true` is only one of the necessary conditions for being focusable. A widget must also be sensitive and focusable and not have an ancestor that is marked as not can-focus in order to receive input focus.

See grab_focus() for actually setting the input focus on a widget.

Parameters

  can_focus | Whether or not the input focus can enter the widget or any of its children.

## ◆ set_can_target()

void Gtk::Widget::set_can_target | ( | bool | can_target = `true` | ) |

Sets whether widget can be the target of pointer events.

Parameters

  can_target | Whether this widget should be able to receive pointer events.

## ◆ set_child_visible()

void Gtk::Widget::set_child_visible | ( | bool | visible = `true` | ) |

Sets whether widget should be mapped along with its parent.

The child visibility can be set for widget before it is added to a container with set_parent(), to avoid mapping children unnecessary before immediately unmapping them. However it will be reset to its default state of `true` when the widget is removed from a container.

Note that changing the child visibility of a widget does not queue a resize on the widget. Most of the time, the size of a widget is computed from all visible children, whether or not they are mapped. If this is not the case, the container can queue a resize itself.

This function is only useful for container implementations and should never be called by an application.

Parameters

  visible | If `true`, widget should be mapped along with its parent.

## ◆ set_css_classes()

void Gtk::Widget::set_css_classes | ( | const std::vector< Glib::ustring > & | classes | ) |

Clear all style classes applied to widget and replace them with classes.

Parameters

  classes | `nullptr`-terminated list of style classes to apply to widget.

## ◆ set_cursor() [1/2]

void Gtk::Widget::set_cursor | ( | const Glib::RefPtr< Gdk::Cursor > & | cursor | ) |

Sets the cursor to be shown when pointer devices point towards widget.

If the cursor is `nullptr`, widget will use the cursor inherited from the parent widget.

Parameters

  cursor | The new cursor.

## ◆ set_cursor() [2/2]

void Gtk::Widget::set_cursor | ( | const Glib::ustring & | name = `{}` | ) |

Sets a named cursor to be shown when pointer devices point towards the widget.

This is a utility function that creates a cursor and then sets it on the widget.

If the name is an empty string, the widget will use the cursor specified via CSS or the parent widget. If neither specifies a cursor, the default cursor will be shown. This is the default behavior.

Since gtkmm 3.94:

Parameters

  name | The name of the cursor, or an empty string to use the default cursor.

## ◆ set_default_direction()

static void Gtk::Widget::set_default_direction | ( | TextDirection | dir | ) |
| static

Sets the default reading direction for widgets.

See set_direction().

Parameters

  dir | The new default direction. This cannot be Gtk::TextDirection::NONE.

## ◆ set_direction()

void Gtk::Widget::set_direction | ( | TextDirection | dir | ) |

Sets the reading direction on a particular widget.

This direction controls the primary direction for widgets containing text, and also the direction in which the children of a container are packed. The ability to set the direction is present in order so that correct localization into languages with right-to-left reading directions can be done. Generally, applications will let the default reading direction present, except for containers where the containers are arranged in an order that is explicitly visual rather than logical (such as buttons for text justification).

If the direction is set to Gtk::TextDirection::NONE, then the value set by set_default_direction() will be used.

Parameters

  dir | The new direction.

## ◆ set_expand()

void Gtk::Widget::set_expand | ( | bool | expand = `true` | ) |

Sets whether the widget would like any available extra space in both directions.

See also
  set_hexpand() for more detail.

Parameters

  expand | Whether to expand in horizontal and vertical direction.

## ◆ set_focus_child()

void Gtk::Widget::set_focus_child | ( | Widget & | child | ) |
| protected

Set child as the current focus child of widget.

This function is only suitable for widget implementations. If you want a certain widget to get the input focus, call grab_focus() on it.

Parameters

  child | A direct child widget of widget or `nullptr` to unset the focus child of widget.

## ◆ set_focus_child_vfunc()

virtual void Gtk::Widget::set_focus_child_vfunc | ( | Widget * | child | ) |
| protectedvirtual

Sets the focused child of widget.

Parameters

  child | The child widget.

## ◆ set_focus_on_click()

void Gtk::Widget::set_focus_on_click | ( | bool | focus_on_click = `true` | ) |

Sets whether the widget should grab focus when it is clicked with the mouse.

Making mouse clicks not grab focus is useful in places like toolbars where you don’t want the keyboard focus removed from the main area of the application.

Parameters

  focus_on_click | Whether the widget should grab focus when clicked with the mouse.

## ◆ set_focusable()

void Gtk::Widget::set_focusable | ( | bool | focusable = `true` | ) |

Specifies whether widget can own the input focus.

Widget implementations should set focusable to `true` in their init() function if they want to receive keyboard input.

Note that having focusable be `true` is only one of the necessary conditions for being focusable. A widget must also be sensitive and can-focus and not have an ancestor that is marked as not can-focus in order to receive input focus.

See grab_focus() for actually setting the input focus on a widget.

Parameters

  focusable | Whether or not widget can own the input focus.

## ◆ set_font_map()

void Gtk::Widget::set_font_map | ( | const Glib::RefPtr< Pango::FontMap > & | font_map | ) |

Sets the font map to use for Pango rendering.

The font map is the object that is used to look up fonts. Setting a custom font map can be useful in special situations, e.g. when you need to add application-specific fonts to the set of available fonts.

When not set, the widget will inherit the font map from its parent.

Parameters

  font_map | A `Pango::FontMap`, or `nullptr` to unset any previously set font map.

## ◆ set_font_options()

void Gtk::Widget::set_font_options | ( | const Cairo::FontOptions & | options | ) |

Sets the `cairo_font_options_t` used for Pango rendering in this widget.

When not set, the default font options for the `Gdk::Display` will be used.

Deprecated: 4.16

Deprecated:
  There is no replacement.

Parameters

  options | A `cairo_font_options_t` to unset any previously set default font options.

## ◆ set_halign()

void Gtk::Widget::set_halign | ( | Align | align | ) |

Sets the horizontal alignment of widget.

Parameters

  align | The horizontal alignment.

## ◆ set_has_tooltip()

void Gtk::Widget::set_has_tooltip | ( | bool | has_tooltip = `TRUE` | ) |

Sets the `has-tooltip` property on widget to has_tooltip.

Parameters

  has_tooltip | Whether or not widget has a tooltip.

## ◆ set_hexpand()

void Gtk::Widget::set_hexpand | ( | bool | expand = `true` | ) |

Sets whether the widget would like any available extra horizontal space.

When a user resizes a `Gtk::Window`, widgets with expand=`true` generally receive the extra space. For example, a list or scrollable area or document in your window would often be set to expand.

Call this function to set the expand flag if you would like your widget to become larger horizontally when the window has extra room.

By default, widgets automatically expand if any of their children want to expand. (To see if a widget will automatically expand given its current children and state, call compute_expand(). A container can decide how the expandability of children affects the expansion of the container by overriding the compute_expand virtual method on `Gtk::Widget`.).

Setting hexpand explicitly with this function will override the automatic expand behavior.

This function forces the widget to expand or not to expand, regardless of children. The override occurs because set_hexpand() sets the hexpand-set property (see set_hexpand_set()) which causes the widget’s hexpand value to be used, rather than looking at children and widget state.

Parameters

  expand | Whether to expand.

## ◆ set_hexpand_set()

void Gtk::Widget::set_hexpand_set | ( | bool | set = `true` | ) |

Sets whether the hexpand flag will be used.

The property_hexpand_set() property will be set automatically when you call set_hexpand() to set hexpand, so the most likely reason to use this function would be to unset an explicit expand flag.

If hexpand is set, then it overrides any computed expand value based on child widgets. If hexpand is not set, then the expand value depends on whether any children of the widget would like to expand.

There are few reasons to use this function, but it’s here for completeness and consistency.

Parameters

  set | Value for hexpand-set property.

## ◆ set_layout_manager()

void Gtk::Widget::set_layout_manager | ( | const Glib::RefPtr< LayoutManager > & | layout_manager | ) |

Sets the layout manager delegate instance that provides an implementation for measuring and allocating the children of widget.

Parameters

  layout_manager | A `Gtk::LayoutManager`.

## ◆ set_margin()

void Gtk::Widget::set_margin | ( | int | margin | ) |

Set all 4 margins to the same value.

Parameters

  margin | The start, end, top, and bottom margin.

## ◆ set_margin_bottom()

void Gtk::Widget::set_margin_bottom | ( | int | margin | ) |

Sets the bottom margin of widget.

Parameters

  margin | The bottom margin.

## ◆ set_margin_end()

void Gtk::Widget::set_margin_end | ( | int | margin | ) |

Sets the end margin of widget.

Parameters

  margin | The end margin.

## ◆ set_margin_start()

void Gtk::Widget::set_margin_start | ( | int | margin | ) |

Sets the start margin of widget.

Parameters

  margin | The start margin.

## ◆ set_margin_top()

void Gtk::Widget::set_margin_top | ( | int | margin | ) |

Sets the top margin of widget.

Parameters

  margin | The top margin.

## ◆ set_name()

void Gtk::Widget::set_name | ( | const Glib::ustring & | name | ) |

Sets a widgets name.

Setting a name allows you to refer to the widget from a CSS file. You can apply a style to widgets with a particular name in the CSS file. See the documentation for the CSS syntax (on the same page as the docs for Gtk::StyleContext.

Note that the CSS syntax has certain special characters to delimit and represent elements in a selector (period, #, >, *...), so using these will make your widget impossible to match by name. Any combination of alphanumeric symbols, dashes and underscores will suffice.

Parameters

  name | Name for the widget.

## ◆ set_opacity()

void Gtk::Widget::set_opacity | ( | double | opacity | ) |

Request the widget to be rendered partially transparent.

An opacity of 0 is fully transparent and an opacity of 1 is fully opaque.

Opacity works on both toplevel widgets and child widgets, although there are some limitations: For toplevel widgets, applying opacity depends on the capabilities of the windowing system. On X11, this has any effect only on X displays with a compositing manager, see gdk_display_is_composited(). On Windows and Wayland it should always work, although setting a window’s opacity after the window has been shown may cause some flicker.

Note that the opacity is inherited through inclusion — if you set a toplevel to be partially translucent, all of its content will appear translucent, since it is ultimatively rendered on that toplevel. The opacity value itself is not inherited by child widgets (since that would make widgets deeper in the hierarchy progressively more translucent). As a consequence, Gtk::Popovers and other Gtk::Native widgets with their own surface will use their own opacity value, and thus by default appear non-translucent, even if they are attached to a toplevel that is translucent.

Parameters

  opacity | Desired opacity, between 0 and 1.

## ◆ set_overflow()

void Gtk::Widget::set_overflow | ( | Overflow | overflow | ) |

Sets how widget treats content that is drawn outside the widget's content area.

See the definition of Gtk::Overflow for details.

This setting is provided for widget implementations and should not be used by application code.

The default value is Gtk::Overflow::VISIBLE.

Since gtkmm 3.96:

Parameters

  overflow | Desired overflow.

## ◆ set_parent()

void Gtk::Widget::set_parent | ( | Widget & | parent | ) |

Sets parent as the parent widget of widget.

This takes care of details such as updating the state and style of the child to reflect its new location and resizing the parent. The opposite function is unparent().

This function is useful only when implementing subclasses of `Gtk::Widget`.

Parameters

  parent | Parent widget.

## ◆ set_receives_default()

void Gtk::Widget::set_receives_default | ( | bool | receives_default = `true` | ) |

Specifies whether widget will be treated as the default widget within its toplevel when it has the focus, even if another widget is the default.

Parameters

  receives_default | Whether or not widget can be a default widget.

## ◆ set_sensitive()

void Gtk::Widget::set_sensitive | ( | bool | sensitive = `true` | ) |

Sets the sensitivity of a widget.

A widget is sensitive if the user can interact with it. Insensitive widgets are “grayed out” and the user can’t interact with them. Insensitive widgets are known as “inactive”, “disabled”, or “ghosted” in some other toolkits.

Parameters

  sensitive | `true` to make the widget sensitive.

## ◆ set_size_request()

void Gtk::Widget::set_size_request | ( | int | width = `-1`,
|  | int | height = `-1`
| ) |  |

Sets the minimum size of a widget.

That is, the widget’s size request will be at least width by height. You can use this function to force a widget to be larger than it normally would be.

In most cases, Gtk::Window::set_default_size() is a better choice for toplevel windows than this function; setting the default size will still allow users to shrink the window. Setting the size request will force them to leave the window at least as large as the size request.

Note the inherent danger of setting any fixed size - themes, translations into other languages, different fonts, and user action can all change the appropriate size for a given widget. So, it's basically impossible to hardcode a size that will always be correct.

The size request of a widget is the smallest size a widget can accept while still functioning well and drawing itself correctly. However in some strange cases a widget may be allocated less than its requested size, and in many cases a widget may be allocated more space than it requested.

If the size request in a given direction is -1 (unset), then the “natural” size request of the widget will be used instead.

The size request set here does not include any margin from the properties property_margin_start(), property_margin_end(), property_margin_top(), and property_margin_bottom(), but it does include pretty much all other padding or border properties set by any subclass of `Gtk::Widget`.

Parameters

  width | Width widget should request, or -1 to unset.
  height | Height widget should request, or -1 to unset.

## ◆ set_state_flags()

void Gtk::Widget::set_state_flags | ( | StateFlags | flags,
|  | bool | clear = `true`
| ) |  |

Turns on flag values in the current widget state.

Typical widget states are insensitive, prelighted, etc.

This function accepts the values Gtk::StateFlags::DIR_LTR and Gtk::StateFlags::DIR_RTL but ignores them. If you want to set the widget's direction, use set_direction().

This function is for use in widget implementations.

Parameters

  flags | State flags to turn on.
  clear | Whether to clear state before turning on flags.

## ◆ set_tooltip_markup()

void Gtk::Widget::set_tooltip_markup | ( | const Glib::ustring & | markup | ) |

Sets markup as the contents of the tooltip, which is marked up with the Pango text markup language.

This function will take care of setting GtkWidget:has-tooltip to `true` and of the default handler for the GtkWidget::query-tooltip signal.

See also the GtkWidget:tooltip-markup property and Gtk::Tooltip::set_markup().

Since gtkmm 2.12:

Parameters

  markup | The contents of the tooltip for widget.

## ◆ set_tooltip_text()

void Gtk::Widget::set_tooltip_text | ( | const Glib::ustring & | text | ) |

Sets text as the contents of the tooltip.

If text contains any markup, it will be escaped.

This function will take care of setting property_has_tooltip() as a side effect, and of the default handler for the signal_query_tooltip() signal.

See also Gtk::Tooltip::set_text().

Parameters

  text | The contents of the tooltip for widget.

## ◆ set_valign()

void Gtk::Widget::set_valign | ( | Align | align | ) |

Sets the vertical alignment of widget.

Parameters

  align | The vertical alignment.

## ◆ set_vexpand()

void Gtk::Widget::set_vexpand | ( | bool | expand = `true` | ) |

Sets whether the widget would like any available extra vertical space.

See set_hexpand() for more detail.

Parameters

  expand | Whether to expand.

## ◆ set_vexpand_set()

void Gtk::Widget::set_vexpand_set | ( | bool | set = `true` | ) |

Sets whether the vexpand flag will be used.

See set_hexpand_set() for more detail.

Parameters

  set | Value for vexpand-set property.

## ◆ set_visible()

void Gtk::Widget::set_visible | ( | bool | visible = `true` | ) |

Sets the visibility state of widget.

Note that setting this to `true` doesn’t mean the widget is actually viewable, see get_visible().

Parameters

  visible | Whether the widget should be shown or not.

## ◆ should_layout()

bool Gtk::Widget::should_layout | ( |  | ) | const

Returns whether widget should contribute to the measuring and allocation of its parent.

This is `false` for invisible children, but also for children that have their own surface.

Returns
  `true` if child should be included in measuring and allocating.

## ◆ show()

void Gtk::Widget::show | ( |  | ) |

Flags a widget to be displayed.

Any widget that isn’t shown will not appear on the screen.

Remember that you have to show the containers containing a widget, in addition to the widget itself, before it will appear onscreen.

When a toplevel container is shown, it is immediately realized and mapped; other shown widgets are realized and mapped when their toplevel container is realized and mapped.

Deprecated: 4.10: Use set_visible() instead

Deprecated:
  Use set_visible() instead.

## ◆ signal_destroy()

Glib::SignalProxy< void()> Gtk::Widget::signal_destroy | ( |  | ) |

Emitted during the dispose phase.

You need to connect to this signal only if you are implementing a widget, which

1. is a direct descendant of Gtk::Widget,
2. contains other widgets (is a container widget), and
3. shall work well as a managed object.

The children of the object need to be unparented both from the handler of this signal and from the destructor. Reason: when your class is used as a managed object, then the C++ destructor is called too late, but when your class is managed via the standard C++ manner, then this signal is not emitted at all.

When your class inherits from a container widget, such as Gtk::Box, you do not need to handle this signal. When your widget does not have child widgets, then you also do not need to handle this signal.

This signal is emitted by Gtk::Widget during the dispose phase of object destruction. See the Reference count section in the GObject concepts documentation for the specification of the dispose and the finalize phases of object destruction. After dispose, the object is not supposed to hold any reference to other member objects.

Dispose may be called multiple times, so your implementation of this signal must tolerate that.

Slot Prototype:
  `void on_my_destroy()`

Flags: Run Cleanup, No Recurse, No Hooks

Signals that all holders of a reference to the widget should release the reference that they hold.

May result in finalization of the widget if all references are released.

This signal is not suitable for saving widget state.

Since gtkmm 4.8:

## ◆ signal_direction_changed()

Glib::SignalProxy< void(TextDirection)> Gtk::Widget::signal_direction_changed | ( |  | ) |

Slot Prototype:
  `void on_my_direction_changed(TextDirection direction)`

Flags: Run First

Emitted when the text direction of a widget changes.

Parameters

  direction | The previous text direction of widget.

## ◆ signal_hide()

Glib::SignalProxy< void()> Gtk::Widget::signal_hide | ( |  | ) |

Slot Prototype:
  `void on_my_hide()`

Flags: Run First

Emitted when widget is hidden.

## ◆ signal_map()

Glib::SignalProxy< void()> Gtk::Widget::signal_map | ( |  | ) |

Emitted on mapping of a widget to the screen.

Slot Prototype:
  `void on_my_map()`

Flags: Run First

Emitted when widget is going to be mapped.

A widget is mapped when the widget is visible (which is controlled with property_visible()) and all its parents up to the toplevel widget are also visible.

The signal_map() signal can be used to determine whether a widget will be drawn, for instance it can resume an animation that was stopped during the emission of signal_unmap().

## ◆ signal_mnemonic_activate()

Glib::SignalProxy< bool(bool)> Gtk::Widget::signal_mnemonic_activate | ( |  | ) |

Slot Prototype:
  `bool on_my_mnemonic_activate(bool group_cycling)`

Flags: Run Last

Emitted when a widget is activated via a mnemonic.

The default handler for this signal activates widget if group_cycling is `false`, or just makes widget grab focus if group_cycling is `true`.

Parameters

  group_cycling | `true` if there are other widgets with the same mnemonic.

Returns
  `true` to stop other handlers from being invoked for the event. `false` to propagate the event further.

## ◆ signal_query_tooltip()

Glib::SignalProxy< bool(int, int, bool, const Glib::RefPtr< Tooltip > &)> Gtk::Widget::signal_query_tooltip | ( |  | ) |

Slot Prototype:
  `bool on_my_query_tooltip(int x, int y, bool keyboard_tooltip, const Glib::RefPtr<Tooltip>& tooltip)`

Flags: Run Last

Emitted when the widget’s tooltip is about to be shown.

This happens when the property_has_tooltip() property is `true` and the hover timeout has expired with the cursor hovering "above" widget; or emitted when widget got focus in keyboard mode.

Using the given coordinates, the signal handler should determine whether a tooltip should be shown for widget. If this is the case `true` should be returned, `false` otherwise. Note that if keyboard_tooltip is `true`, the values of x and y are undefined and should not be used.

The signal handler is free to manipulate tooltip with the therefore destined function calls.

Parameters

  x | The x coordinate of the cursor position where the request has been emitted, relative to widget's left side.
  y | The y coordinate of the cursor position where the request has been emitted, relative to widget's top.
  keyboard_tooltip | `true` if the tooltip was triggered using the keyboard.
  tooltip | A `Gtk::Tooltip`.

Returns
  `true` if tooltip should be shown right now, `false` otherwise.

## ◆ signal_realize()

Glib::SignalProxy< void()> Gtk::Widget::signal_realize | ( |  | ) |

Emitted on realization of a widget.

Slot Prototype:
  `void on_my_realize()`

Flags: Run First

Emitted when widget is associated with a `Gdk::Surface`.

This means that Gtk::Widget::realize() has been called or the widget has been mapped (that is, it is going to be drawn).

## ◆ signal_show()

Glib::SignalProxy< void()> Gtk::Widget::signal_show | ( |  | ) |

Slot Prototype:
  `void on_my_show()`

Flags: Run First

Emitted when widget is shown.

## ◆ signal_state_flags_changed()

Glib::SignalProxy< void(Gtk::StateFlags)> Gtk::Widget::signal_state_flags_changed | ( |  | ) |

Slot Prototype:
  `void on_my_state_flags_changed(Gtk::StateFlags previous_state_flags)`

Flags: Run First

Emitted when the widget state changes.

See Gtk::Widget::get_state_flags().

Parameters

  previous_state_flags | The previous state flags.

## ◆ signal_unmap()

Glib::SignalProxy< void()> Gtk::Widget::signal_unmap | ( |  | ) |

Slot Prototype:
  `void on_my_unmap()`

Flags: Run First

Emitted when widget is going to be unmapped.

A widget is unmapped when either it or any of its parents up to the toplevel widget have been set as hidden.

As signal_unmap() indicates that a widget will not be shown any longer, it can be used to, for example, stop an animation on the widget.

## ◆ signal_unrealize()

Glib::SignalProxy< void()> Gtk::Widget::signal_unrealize | ( |  | ) |

Slot Prototype:
  `void on_my_unrealize()`

Flags: Run Last

Emitted when the `Gdk::Surface` associated with widget is destroyed.

This means that Gtk::Widget::unrealize() has been called or the widget has been unmapped (that is, it is going to be hidden).

## ◆ size_allocate()

void Gtk::Widget::size_allocate | ( | const Allocation & | allocation,
|  | int | baseline
| ) |  |

Allocates widget with a transformation that translates the origin to the position in allocation.

This is a simple form of allocate().

Parameters

  allocation | Position and size to be allocated to widget.
  baseline | The baseline of the child, or -1.

## ◆ size_allocate_vfunc()

virtual void Gtk::Widget::size_allocate_vfunc | ( | int | width,
|  | int | height,
|  | int | baseline
| ) |  |
| protectedvirtual

## ◆ snapshot_child()

void Gtk::Widget::snapshot_child | ( | Widget & | child,
|  | const Glib::RefPtr< Gtk::Snapshot > & | snapshot
| ) |  |

Snapshot the a child of widget.

When a widget receives a call to the snapshot function, it must send synthetic snapshot_vfunc() calls to all children. This function provides a convenient way of doing this. A widget, when it receives a call to its snapshot_vfunc() function, calls snapshot_child() once for each child, passing in the snapshot the widget received.

snapshot_child() takes care of translating the origin of snapshot, and deciding whether the child needs to be snapshot.

This function does nothing for children that implement `Gtk::Native`.

Parameters

  child | A child of widget.
  snapshot | `Gtk::Snapshot` as passed to the widget. In particular, no calls to Gtk::Snapshot::translate() or other transform calls should have been made.

## ◆ snapshot_vfunc()

virtual void Gtk::Widget::snapshot_vfunc | ( | const Glib::RefPtr< Gtk::Snapshot > & | snapshot | ) |
| protectedvirtual

## ◆ translate_coordinates()

bool Gtk::Widget::translate_coordinates | ( | Widget & | dest_widget,
|  | double | src_x,
|  | double | src_y,
|  | double & | dest_x,
|  | double & | dest_y
| ) |  |

Translate coordinates relative to src_widget’s allocation to coordinates relative to dest_widget’s allocations.

In order to perform this operation, both widget must share a common ancestor.

Deprecated: 4.12: Use compute_point() instead

Deprecated:
  Use compute_point() instead

Parameters

  dest_widget | A `Gtk::Widget`.
  src_x | X position relative to src_widget.
  src_y | Y position relative to src_widget.
  dest_x | Location to store X position relative to dest_widget.
  dest_y | Location to store Y position relative to dest_widget.

Returns
  `false` if src_widget and dest_widget have no common ancestor. In this case, 0 is stored in * dest_x and * dest_y. Otherwise `true`.

## ◆ trigger_tooltip_query()

void Gtk::Widget::trigger_tooltip_query | ( |  | ) |

Triggers a tooltip query on the display where the toplevel of widget is located.

## ◆ unmap()

void Gtk::Widget::unmap | ( |  | ) |

Causes a widget to be unmapped if it’s currently mapped.

This function is only for use in widget implementations.

## ◆ unparent()

void Gtk::Widget::unparent | ( |  | ) |

Dissociate widget from its parent.

This function is only for use in widget implementations, typically in dispose.

## ◆ unrealize()

void Gtk::Widget::unrealize | ( |  | ) |
| protected

Causes a widget to be unrealized (frees all GDK resources associated with the widget).

This function is only useful in widget implementations.

## ◆ unroot_vfunc()

virtual void Gtk::Widget::unroot_vfunc | ( |  | ) |
| protectedvirtual

## ◆ unset_focus_child()

void Gtk::Widget::unset_focus_child | ( |  | ) |
| protected

Unsets the focus child of the widget.

The previous focus child will be unset.

This function is only suitable for widget implementations.

## ◆ unset_font_options()

void Gtk::Widget::unset_font_options | ( |  | ) |

Undoes the effect of previous calls to set_font_options().

Since gtkmm 3.20:

Deprecated:
  4.16: There is no replacement.

## ◆ unset_layout_manager()

void Gtk::Widget::unset_layout_manager | ( |  | ) |

Undoes the effect of a previous call to set_layout_manager().

## ◆ unset_name()

void Gtk::Widget::unset_name | ( |  | ) |

## ◆ unset_state_flags()

void Gtk::Widget::unset_state_flags | ( | StateFlags | flags | ) |

Turns off flag values for the current widget state.

See set_state_flags().

This function is for use in widget implementations.

Parameters

  flags | State flags to turn off.

## Friends And Related Symbol Documentation

## ◆ wrap()

Gtk::Widget * wrap | ( | GtkWidget * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.